/*------------------------------------------------------------------------------
    
------------------------------------------------------------------------------*/
enum {
	RAW,
	HALF,
	QUARTER,
};

enum {
	LEFT,
	CENTER,
	RIGHT,
};

enum {
	WHITE,
	SILVER,
	GRAY,
	SHADOW,
	BLACK,
	FREE,
	AVERAGE,
	POLKA,
	STRIPE,
	CHECK,
};

enum {
	LOADING,
	SAVING,
	ROTATING,
	FLIPPING,
	EFFECTING,
	RESIZING,
	COPYING,
	PASTING,
	CREATING,
};

enum {
	UNDEF,
	BMP,
	PNG,
	JPG,
	ICO,
};

/*------------------------------------------------------------------------------
    t|[hL@
------------------------------------------------------------------------------*/
enum {
	PLSH_ERR_CHECKBLOCK = 0,
	PLSH_ERR_FORMULA,
	PLSH_ERR_EXPRESSION,
	PLSH_ERR_LEN,
	PLSH_ERR_TERMCNTL,
	PLSH_ERR_TERMCNTR,
	PLSH_ERR_PUSHDECODE,
	PLSH_ERR_DIV0,
	PLSH_ERR_DECODEREMAIN,
	PLSH_NOERROR,
	PLSH_RESCNT,
};

/*------------------------------------------------------------------------------
    j[
------------------------------------------------------------------------------*/
enum {
	E_TITLE,
	E_VERSION,
	E_FILE,
	E_VIEW,
	E_PAGE,
	E_WINDOW,
	E_EFFECT,
	E_EDIT,
	E_OPTION,
	E_ETC,
	E_OPEN,
	E_CLOSE,
	E_RECENT,
	E_BOOK,
	E_BOOKSAVE,
	E_LIST,
	E_FOLDER,
	E_RECYCLE,
	E_PC,
	E_FDESKTOP,
	E_DOC,
	E_FPICTURE,
	E_RENAME,
	E_DELETE,
	E_DELETE2,
	E_SUBFOLDER,
	E_RELOAD,
	E_SAVEOV,
	E_SAVENM,
	E_SAVENMRAW,
	E_SAVENMBMP,
	E_SAVENMPNG,
	E_SAVENMJPG,
	E_NEW,
	E_PRINT,
	E_EXIT,
	E_FULL,
	E_NEXT,
	E_PREV,
	E_HOME,
	E_END,
	E_UP,
	E_DOWN,
	E_100,
	E_UNDO,
	E_ROTATE_R,
	E_ROTATE_L,
	E_FLIP_UD,
	E_FLIP_LR,
	E_DUAL,
	E_TRIPLE,
	E_QUAD,
	E_OCTA,
	E_HEXADECA,
	E_DOTRIACONTA,
	E_DESIGN,
	E_VERT,
	E_THUMB,
	E_WNEW,
	E_WNEXT,
	E_WPREV,
	E_WCLOSE,
	E_MONO,
	E_GRAD4,
	E_INV,
	E_SEPIA,
	E_BRIGHTUP,
	E_BRIGHTDW,
	E_SATURATION,
	E_R_ONLY,
	E_G_ONLY,
	E_B_ONLY,
	E_ROUNDUP,
	E_ROUNDDW,
	E_SWAP,
	E_GRID,
	E_XY,
	E_AREA,
	E_MARGIN,
	E_DEFORM,
	E_ANGLE,
	E_RESIZE,
	E_TEXT,
	E_LINE,
	E_RECT,
	E_CSV,
	E_PEN,
	E_FILL,
	E_ALLWHITE,
	E_CLIP,
	E_COPY,
	E_COPPAT,
	E_PASTE,
	E_PAPARA,
	E_PACRE,
	E_TLB,
	E_STB,
	E_SCB,
	E_PV,
	E_TRIM,
	E_TURN,
	E_DUALORDER,
	E_VERTOP,
	E_THUMBOP,
	E_TBPOS,
	E_LANG,
	E_PRIO,
	E_ENDECO,
	E_TURNRIGHT,
	E_TURNLEFT,
	E_DUALORDERASC,
	E_DUALORDERDSC,
	E_DUALORDERTOG,
	E_VERTWIDTH,
	E_300PX,
	E_400PX,
	E_500PX,
	E_600PX,
	E_VERTPAGES,
	E_10PAGES,
	E_20PAGES,
	E_50PAGES,
	E_VERTMARG,
	E_4DOT,
	E_8DOT,
	E_20DOT,
	E_THUMBCNT,
	E_50PIC,
	E_100PIC,
	E_150PIC,
	E_THUMBSIZE,
	E_100PX,
	E_150PX,
	E_200PX,
	E_TBPOSBT,
	E_TBPOSLF,
	E_TBPOSTP,
	E_TBPOSRT,
	E_TBPOSNEXT,
	E_SVGA,
	E_WXGA,
	E_FHD,
	E_JAP,
	E_ENG,
	E_HIGHEST,
	E_ABOVE,
	E_NORMAL,
	E_BELOW,
	E_LOWEST,
	E_THR,
	E_THRVT,
	E_THRTH,
	E_THRLT,
	E_BMP,
	E_PNG,
	E_JPG,
	E_ICO,
	E_BMPSELF,
	E_BMPGDI,
	E_PNGGDI,
	E_JPGGDI,
	E_ICOSELF,
	E_DEBUG,
	E_DEBUG1,
	E_DEBUG2,
	E_DEBUG3,
	E_DEBUG4,
	E_DEBUG5,
	E_DEBUG6,
	E_DEBUG7,
	E_DEBUG8,
	E_DUMP,
	E_ALLTRUE,
	E_ALLFALSE,
	E_IGNORE,
	E_CLEAR,
	E_KCODE,
	E_PROMPT,
	E_MONIOFF,
	E_MANU,
	E_SKEY,
	E_PUNEW,
	E_PUEXP,
	E_PUPHVW,
	E_RESET,
	E_DESKTOP,
	E_PICTURE,
	E_ANALYSE,
	E_PROPERTY,
	E_WHITE,
	E_SILVER,
	E_GRAY,
	E_SHADOW,
	E_BLACK,
	E_FREE,
	E_AVERAGE,
	E_POLKA,
	E_STRIPE,
	E_CHECK,
	//--------------------------------------------------------------------------
	E_OVROTATE,
	E_OVFLIP,
	E_OVEFFECT,
	E_OVRESIZE,
	E_OVAREA,
	E_OVMARGIN,
	E_OVDEFORM,
	E_OVANGLE,
	E_OVTEXT,
	E_OVLINE,
	E_OVRECT,
	E_OVCSV,
	E_OVPEN,
	E_OVFILL,
	E_OVWHITE,
	E_OVPASTE,
	E_OVPAPARA,
	E_AS,
};

enum {
	E_TTLBKM,
	E_TTLREM,
	E_TTLSBF,
	E_TTLDEL,
	E_TTLSOV,
	E_TTLNEW,
	E_TTLPRN,
	E_TTLSWP,
	E_TTLARA,
	E_TTLMAR,
	E_TTLDFM,
	E_TTLAGL,
	E_TTLSTR,
	E_TTLFNT,
	E_TTLLIN,
	E_TTLRCT,
	E_TTLCSV,
	E_TTLPEN,
	E_TTLFIL,
	E_TTLCPT,
	E_TTLPPR,
	E_TTLPCR,
	E_TTLINV,
	E_TTLMAN,
	E_TTLSHK,
	E_TTLMVO,
	E_TTLANA,
	E_TTLFREE,
	E_TTLRSZ,
	E_TTLSAM,
	E_TTLRGB,
};

enum {
	E_DLGOPEN,
	E_DLGCSV,
	E_DLGOPENWITH,
	E_DLGRGB,
};

enum {
	E_OK,
	E_CANCEL,
	E_APPLY,
	E_NSNAME,
	E_NSWIDTH,
	E_NSHEIGHT,
	E_PRBTN,
	E_PRPAPER,
	E_PRLANDSCAPE,
	E_PRSCALE,
	E_PRPORT,
	E_PRLAND,
	E_PRMONO,
	E_PRCOLOR,
	E_MRTOP,
	E_MRBOTTOM,
	E_MRLEFT,
	E_MRRIGHT,
	E_DMWIDTH,
	E_DMHEIGHT,
	E_DMASPECT,
	E_ANANGLE,
	E_ANBACK,
	E_ANANTI,
	E_ANKEEP,
	E_TXTEXT,
	E_TXFORE,
	E_TXBACK,
	E_TXTRANS,
	E_TXFONT,
	E_TXSIZE,
	E_TXVERT,
	E_LNCOLOR,
	E_LNTHICK,
	E_RTWIDTH,
	E_RTHEIGHT,
	E_RTFORE,
	E_RTBACK,
	E_RTTHICK,
	E_RTCORNER,
	E_RTFILL,
	E_RTONLY,
	E_RTELIPSE,
	E_RTLSHAPED,
	E_PNCOLOR,
	E_PNTHICK,
	E_FLCOLOR,
	E_PPTRANS,
	E_PPCHROMA,
	E_PPPERCENT,
	E_PPKEEP,
	E_PPBACK,
};

enum {
	E_FMTPUEXE,
	E_FMTPUMOVE,
	E_FMTCMPDEL,
	E_FMTREM,
	E_FMTSBF,
	E_FMTNEW,
	E_FMTMOVE,
};

enum {
	E_SEP_F_0=0x400,
	E_SEP_F_1,
	E_SEP_F_2,
	E_SEP_F_3,
	E_SEP_V_0,
	E_SEP_V_1,
	E_SEP_V_2,
	E_SEP_P_0,
	E_SEP_P_1,
	E_SEP_W_0,
	E_SEP_W_1,
	E_SEP_E_0,
	E_SEP_E_1,
	E_SEP_E_2,
	E_SEP_E_3,
	E_SEP_E_4,
	E_SEP_I_0,
	E_SEP_I_1,
	E_SEP_I_2,
	E_SEP_I_3,
	E_SEP_I_4,
	E_SEP_O_0,
	E_SEP_O_1,
	E_SEP_O_2,
	E_SEP_O_3,
	E_SEP_O_4,
	E_SEP_T_0,
	E_SEP_T_1,
	E_SEP_D_0,
	E_SEP_D_1,
	E_SEP_N_0,
	E_SEP_PP_0,
	E_SEP_PP_1,
	E_SEP_PP_2,
	E_SEP_PC_0,
};

/*------------------------------------------------------------------------------
    ݒ
------------------------------------------------------------------------------*/
enum {
	OP_PTBF,
	OP_DVRD,
	OP_SZED,
	OP_NONE,
};
