/*------------------------------------------------------------------------------
    VXeCN[h
------------------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <tchar.h>
#include <windows.h>
#include <shlwapi.h>
#include <shlobj.h>
#include <shellapi.h>
#include <commdlg.h>
#include <Winspool.h>
#include <gdiplus.h>
using namespace Gdiplus;

/*------------------------------------------------------------------------------
    ˑ
------------------------------------------------------------------------------*/
#pragma resource "icon.RES"
// sub.bat
// main.bat
//------------------------------------------------------------------------------
// 񃊃eLtB
// UTF-8:   8-32bit
// UTF-16: 16-32bit
// UTF-32:    32bit
// strlenwcslen
// strcpywcscpy
// strcatwcscat
// strcmpwcscmp
// swprintf
// atoi_wtoi
// itoa_itow
/*----------------------------------------------------------------------------*/
// CHAR :}`oCg
// WCHAR:Ch
// TCHAR:CHAR or WCHAR
/*----------------------------------------------------------------------------*/
// PPointerALPLong Pointer
// PSTR,   LPSTR  :CHAR |C^
// PCSTR,  LPCSTR :CHAR |C^iRXgj
// PWSTR,  LPWSTR :WCHAR|C^
// PCWSTR, LPCWSTR:WCHAR|C^iRXgj
// PTSTR   :PSTR   or PWSTR
// PCTSTR  :PCSTR  or PCWSTR
// LPTSTR  :LPSTR  or LPWSTR
// LPCTSTR :LPCSTR or LPCWSTR

/*------------------------------------------------------------------------------
    ^
------------------------------------------------------------------------------*/
typedef          int       BOOL;
typedef unsigned char      UINT8;
typedef signed   char      INT8;
typedef          char      ACHAR;
typedef unsigned short     UINT16;
typedef signed   short     INT16;
typedef unsigned int       UINT32;
typedef signed   int       INT32;
typedef unsigned long      ULOG32;
typedef signed   long      LOG32;
typedef unsigned long long UINT64;
typedef signed   long long INT64;

/*------------------------------------------------------------------------------
    ft@C
------------------------------------------------------------------------------*/
#define NM_VERSION       L"22.10"
#define NM_MUTEX_ALREADY L"SPV2210_MUTEX_ALREADY"
#define NM_CORE          L"SPV2210_CORE"
#define NM_REQ           L"SPV2210_REQ"
#define NM_FORM          L"SPV2210_FORM"
#define NM_CNTN          L"SPV2210_CNTN"
#define NM_PICT          L"SPV2210_PICT"
#define NM_TOOL          L"SPV2210_TOOL"
#define NM_ITEM          L"SPV2210_ITEM"
#define NM_STAT          L"SPV2210_STAT"
#define NM_CHIP          L"SPV2210_CHIP"
#define NM_INFO          L"SPV2210_INFO"
#define NM_VPAGE         L"SPV2210_VPAGE"
#define NM_VBACK         L"SPV2210_VBACK"
#define NM_VPICT         L"SPV2210_VPICT"
#define NM_VSCRL         L"SPV2210_VSCRL"
#define NM_TPAGE         L"SPV2210_TPAGE"
#define NM_TBACK         L"SPV2210_TBACK"
#define NM_TPICT         L"SPV2210_TPICT"
#define NM_TSCRL         L"SPV2210_TSCRL"
#define NM_LIST          L"SPV2210_LIST"
#define NM_LISTCN        L"SPV2210_LISTCN"
#define NM_LISTPC        L"SPV2210_LISTPC"
#define NM_REM           L"SPV2210_REM"
#define NM_SBF           L"SPV2210_SBF"
#define NM_NSIZE         L"SPV2210_NSIZE"
#define NM_PRINT         L"SPV2210_PRINT"
#define NM_PRINTPD       L"SPV2210_PRINTPD"
#define NM_PRINTAC       L"SPV2210_PRINTAC"
#define NM_PRINTCN       L"SPV2210_PRINTCN"
#define NM_PRINTPC       L"SPV2210_PRINTPC"
#define NM_SWAP          L"SPV2210_SWAP"
#define NM_AREA          L"SPV2210_AREA"
#define NM_AREAPD        L"SPV2210_AREAPD"
#define NM_AREACN        L"SPV2210_AREACN"
#define NM_AREAPC        L"SPV2210_AREAPC"
#define NM_MARGIN        L"SPV2210_MARGIN"
#define NM_DEFORM        L"SPV2210_DEFORM"
#define NM_ANGLE         L"SPV2210_ANGLE"
#define NM_ANGLEPD       L"SPV2210_ANGLEPD"
#define NM_ANGLECN       L"SPV2210_ANGLECN"
#define NM_ANGLEPC       L"SPV2210_ANGLEPC"
#define NM_TEXT          L"SPV2210_TEXT"
#define NM_TEXTPD        L"SPV2210_TEXTPD"
#define NM_TEXTCN        L"SPV2210_TEXTCN"
#define NM_TEXTPC        L"SPV2210_TEXTPC"
#define NM_TEXTFTBOX     L"SPV2210_TEXTFTBOX"
#define NM_TEXTFT        L"SPV2210_TEXTFT"
#define NM_TEXTFTELM     L"SPV2210_TEXTFTELM"
#define NM_LINE          L"SPV2210_LINE"
#define NM_LINEPD        L"SPV2210_LINEPD"
#define NM_LINECN        L"SPV2210_LINECN"
#define NM_LINEPC        L"SPV2210_LINEPC"
#define NM_RECT          L"SPV2210_RECT"
#define NM_RECTPD        L"SPV2210_RECTPD"
#define NM_RECTCN        L"SPV2210_RECTCN"
#define NM_RECTPC        L"SPV2210_RECTPC"
#define NM_PEN           L"SPV2210_PEN"
#define NM_PENPD         L"SPV2210_PENPD"
#define NM_PENCN         L"SPV2210_PENCN"
#define NM_PENPC         L"SPV2210_PENPC"
#define NM_FILL          L"SPV2210_FILL"
#define NM_FILLPD        L"SPV2210_FILLPD"
#define NM_FILLCN        L"SPV2210_FILLCN"
#define NM_FILLPC        L"SPV2210_FILLPC"
#define NM_CSV           L"SPV2210_CSV"
#define NM_CSVPD         L"SPV2210_CSVPD"
#define NM_CSVCN         L"SPV2210_CSVCN"
#define NM_CSVPC         L"SPV2210_CSVPC"
#define NM_COPPAT        L"SPV2210_COPPAT"
#define NM_COPPATPD      L"SPV2210_COPPATPD"
#define NM_COPPATCN      L"SPV2210_COPPATCN"
#define NM_COPPATPC      L"SPV2210_COPPATPC"
#define NM_PAPARA        L"SPV2210_PAPARA"
#define NM_PAPARAPD      L"SPV2210_PAPARAPD"
#define NM_PAPARACN      L"SPV2210_PAPARACN"
#define NM_PAPARAPC      L"SPV2210_PAPARAPC"
#define NM_IGNORE        L"SPV2210_IGNORE"
#define NM_KCODE         L"SPV2210_KEY"
#define NM_MSGBX         L"SPV2210_MSGBX"
#define NM_SKEY          L"SPV2210_SKEY"
#define NM_SKEYBRD       L"SPV2210_SKEYBRD"
#define NM_SKEYBTN       L"SPV2210_SKEYBTN"
#define NM_MVOV          L"SPV2210_MVOV"
#define NM_MVOVDR        L"SPV2210_MVOVDR"
#define NM_MVOVPC        L"SPV2210_MVOVPC"
#define NM_MVOVLB        L"SPV2210_MVOVLB"
#define NM_FREE          L"SPV2210_FREE"
#define NM_SAM           L"SPV2210_SAM"
#define NM_SAMPV         L"SPV2210_SAMPV"
#define NM_RGBBOX        L"SPV2210_RGBBOX"
#define NM_RGB           L"SPV2210_RGB"       // 1i2i3iځAeqA{̓j[
#define NM_RGBPD         L"SPV2210_RGBPD"
#define NM_RGBPC         L"SPV2210_RGBPC"
#define NM_RGBPV         L"SPV2210_RGBPV"
/*----------------------------------------------------------------------------*/
#define N_CORE           0x0
#define N_FORM           0x1
#define N_CNTN           0x2
#define N_PICT           0x3
#define N_TOOL           0x4
#define N_ITEM           0x5
#define N_STAT           0x6
#define N_CHIP           0x7
#define N_INVALID        0xFFFFFFFF
/*----------------------------------------------------------------------------*/
#define WMU_NULL         0x0
#define WMU_REQUEST      0x1
#define WMU_THREND       0x2
#define WMU_THRVTEND     0x3
#define WMU_THRTHEND     0x4
#define WMU_THRLTEND     0x5
#define WMU_THRMOEND     0x6
#define WMU_THRMOLAST    0x7
#define WMU_NEXTPOP      0x8
#define WMU_RGBEND       0x9
/*----------------------------------------------------------------------------*/
#define L_TITLE          (WCHAR *)L"DiamondPhotoViewer"
#define L_DEBUG          (WCHAR *)L"Debug"
#define L_ERROR          (WCHAR *)L"Error"
#define L_FATAL          (WCHAR *)L"Fatal Error"
#define L_BLANK          (WCHAR *)L""
#define L_NONE           (WCHAR *)L"none"
#define L_NOTEXIST       (WCHAR *)L"not exist"
#define L_NOTIMAGE       (WCHAR *)L"not image"
/*----------------------------------------------------------------------------*/
//                       0x001-0x007
#define KEY_BKSP         0x008
#define KEY_TAB          0x009
//                       0x00A-0x00C
#define KEY_ENTER        0x00D
//                       0x00E-0x00F
#define KEY_SHIFT        0x010
#define KEY_CTRL         0x011
#define KEY_ALT          0x012
#define KEY_PAUSE        0x013
//                       0x014-0x01A
#define KEY_ESC          0x01B
//                       0x01C-0x01F
#define KEY_SP           0x020
#define KEY_PGUP         0x021
#define KEY_PGDW         0x022
#define KEY_END          0x023
#define KEY_HOME         0x024
#define KEY_LF           0x025
#define KEY_UP           0x026
#define KEY_RT           0x027
#define KEY_DW           0x028
//                       0x029-0x02C
#define KEY_INSERT       0x02D
#define KEY_DEL          0x02E
//                       0x02F
#define KEY_0            0x030
#define KEY_1            0x031
#define KEY_2            0x032
#define KEY_3            0x033
#define KEY_4            0x034
#define KEY_5            0x035
#define KEY_6            0x036
#define KEY_7            0x037
#define KEY_8            0x038
#define KEY_9            0x039
//                       0x03A-0x03F
//                       0x040
#define KEY_A            0x041
#define KEY_B            0x042
#define KEY_C            0x043
#define KEY_D            0x044
#define KEY_E            0x045
#define KEY_F            0x046
#define KEY_G            0x047
#define KEY_H            0x048
#define KEY_I            0x049
#define KEY_J            0x04A
#define KEY_K            0x04B
#define KEY_L            0x04C
#define KEY_M            0x04D
#define KEY_N            0x04E
#define KEY_O            0x04F
#define KEY_P            0x050
#define KEY_Q            0x051
#define KEY_R            0x052
#define KEY_S            0x053
#define KEY_T            0x054
#define KEY_U            0x055
#define KEY_V            0x056
#define KEY_W            0x057
#define KEY_X            0x058
#define KEY_Y            0x059
#define KEY_Z            0x05A
#define KEY_LWIN         0x05B
#define KEY_RWIN         0x05C
#define KEY_APPS         0x05D
//                       0x05E-0x05F
#define KEY_F1           0x070
#define KEY_F2           0x071
#define KEY_F3           0x072
#define KEY_F4           0x073
#define KEY_F5           0x074
#define KEY_F6           0x075
#define KEY_F7           0x076
#define KEY_F8           0x077
#define KEY_F9           0x078
#define KEY_F10          0x079
#define KEY_F11          0x07A
#define KEY_F12          0x07B
//                       0x07C-0x07F
//                       0x080-0x08F
#define KEY_SCRL         0x091
//                       0x092-0x09F
//                       0x0A0-0x0AF
//                       0x0B0-0x0B9
#define KEY_COLON        0x0BA
#define KEY_SEMI         0x0BB
#define KEY_COMMA        0x0BC
#define KEY_HYPHEN       0x0BD
#define KEY_PERIOD       0x0BE
#define KEY_SLASH        0x0BF
#define KEY_ATSIGN       0x0C0
//                       0x0C1-0x0CF
//                       0x0D0-0x0DA
#define KEY_OEM4         0x0DB
#define KEY_YEN          0x0DC
#define KEY_OEM6         0x0DD
#define KEY_TILDE        0x0DE
//                       0x0DF
//                       0x0E0-0x0E1
#define KEY_BSLASH       0x0E2
//                       0x0E3-0x0E4
#define KEY_IME          0x0E5
//                       0x0E6-0x0EF
//                       0x0F0-0x0FF
/*----------------------------------------------------------------------------*/
#define FLAGS_MAXIMIZE   0x2
#define SHOWCMD_HIDE     0x0
#define SHOWCMD_NORMAL   0x1
#define SHOWCMD_MINIMIZE 0x2
#define SHOWCMD_MAXIMIZE 0x3
/*----------------------------------------------------------------------------*/
#define M_FILE           0x100
#define M_VIEW           0x101
#define M_PAGE           0x102
#define M_WINDOW         0x103
#define M_EFFECT         0x104
#define M_EDIT           0x105
#define M_OPTION         0x106
#define M_ETC            0x107
/*--------------------------*/
#define M_OPEN           0x110
#define M_CLOSE          0x111
#define M_RECENT         0x112
#define M_RECPATH        0x113
#define M_BOOK           0x114
#define M_BOOKPATH       0x115
#define M_BOOKSAVE       0x116
#define M_LIST           0x117
#define M_FOLDER         0x118
#define M_TRASH          0x119
#define M_PC             0x11A
#define M_FDESKTOP       0x11B
#define M_DOC            0x11C
#define M_FPICTURE       0x11D
#define M_RENAME         0x11E
#define M_DELETE         0x11F
#define M_DELETE2        0x120
#define M_SUBFOLDER      0x121
#define M_RELOAD         0x122
#define M_SAVEOV         0x123
#define M_SAVENM         0x124
#define M_SAVENMRAW      0x125
#define M_SAVENMBMP      0x126
#define M_SAVENMPNG      0x127
#define M_SAVENMJPG      0x128
#define M_NEW            0x129
#define M_PRINT          0x12A
#define M_EXIT           0x12B
/*--------------------------*/
#define M_FULL           0x140
#define M_NEXT           0x141
#define M_PREV           0x142
#define M_HOME           0x143
#define M_END            0x144
#define M_UP             0x145
#define M_DOWN           0x146
#define M_100            0x147
#define M_UNDO           0x148
#define M_ROTATE_R       0x149
#define M_ROTATE_L       0x14A
#define M_FLIP_UD        0x14B
#define M_FLIP_LR        0x14C
/*--------------------------*/
#define M_DUAL           0x150
#define M_TRIPLE         0x151
#define M_QUAD           0x152
#define M_OCTA           0x153
#define M_HEXADECA       0x154
#define M_DOTRIACONTA    0x155
#define M_DESIGN         0x156
#define M_VERT           0x157
#define M_THUMB          0x158
/*--------------------------*/
#define M_WNEW           0x160
#define M_WNEXT          0x161
#define M_WPREV          0x162
#define M_WCLOSE         0x163
/*--------------------------*/
#define M_MONO           0x170
#define M_GRAD4          0x171
#define M_INV            0x172
#define M_SEPIA          0x173
#define M_BRIGHTUP       0x174
#define M_BRIGHTDW       0x175
#define M_SATURATION     0x176
#define M_R_ONLY         0x177
#define M_G_ONLY         0x178
#define M_B_ONLY         0x179
#define M_ROUNDUP        0x17A
#define M_ROUNDDW        0x17B
#define M_SWAP           0x17C
/*--------------------------*/
#define M_GRID           0x180
#define M_XY             0x181
#define M_AREA           0x182
#define M_MARGIN         0x183
#define M_DEFORM         0x184
#define M_ANGLE          0x185
#define M_RESIZE         0x186
#define M_TEXT           0x187
#define M_LINE           0x188
#define M_RECT           0x189
#define M_CSV            0x18A
#define M_PEN            0x18B
#define M_FILL           0x18C
#define M_ALLWHITE       0x18D
#define M_CLIP           0x18E
#define M_COPY           0x18F
#define M_COPPAT         0x190
#define M_PASTE          0x191
#define M_PAPARA         0x192
#define M_PACRE          0x193
/*--------------------------*/
#define M_TLB            0x1A0
#define M_STB            0x1A1
#define M_SCB            0x1A2
#define M_PV             0x1A3
#define M_TRIM           0x1A4
#define M_TURN           0x1A5
#define M_SORT           0x1A6
#define M_DUALORDER      0x1A7
#define M_VERTOP         0x1A8
#define M_THUMBOP        0x1A9
#define M_TBPOS          0x1AA
#define M_LANG           0x1AB
#define M_PRIO           0x1AC
#define M_ENDECO         0x1AD
/*--------------------------*/
#define M_VERSION        0x1B0
#define M_DEBUG          0x1B1
#define M_KCODE          0x1B2
#define M_PROMPT         0x1B3
#define M_MONIOFF        0x1B4
#define M_MANU           0x1B5
#define M_SKEY           0x1B6
/*--------------------------*/
	#define M_RIGHT      0x200
	#define M_LEFT       0x201
	#define M_NAME       0x202
	#define M_DATE       0x203
	#define M_SIZE       0x204
	#define M_ASC        0x205
	#define M_DSC        0x206
	#define M_TOG        0x207
	#define M_VERTWIDTH  0x208
	#define M_300PX      0x209
	#define M_400PX      0x20A
	#define M_500PX      0x20B
	#define M_600PX      0x20C
	#define M_VERTPAGES  0x20D
	#define M_10PAGES    0x20E
	#define M_20PAGES    0x20F
	#define M_50PAGES    0x210
	#define M_100PAGES   0x211
	#define M_VERTMARG   0x212
	#define M_4DOT       0x213
	#define M_8DOT       0x214
	#define M_20DOT      0x215
	#define M_THUMBCNT   0x216
	#define M_50PIC      0x217
	#define M_100PIC     0x218
	#define M_150PIC     0x219
	#define M_THUMBSIZE  0x21A
	#define M_100PX      0x21B
	#define M_150PX      0x21C
	#define M_200PX      0x21D
	#define M_TBPOSBT    0x21E
	#define M_TBPOSLF    0x21F
	#define M_TBPOSTP    0x220
	#define M_TBPOSRT    0x221
	#define M_TBPOSNEXT  0x222
	#define M_JAP        0x223
	#define M_ENG        0x224
	#define M_HIGHEST    0x225
	#define M_ABOVE      0x226
	#define M_NORMAL     0x227
	#define M_BELOW      0x228
	#define M_LOWEST     0x229
	#define M_THR        0x22A
	#define M_THRIDX     0x22B
	#define M_THRVT      0x22C
	#define M_THRVTIDX   0x22D
	#define M_THRTH      0x22E
	#define M_THRTHIDX   0x22F
	#define M_THRLT      0x230
	#define M_THRLTIDX   0x231
	#define M_BMP        0x232
	#define M_PNG        0x233
	#define M_JPG        0x234
	#define M_ICO        0x235
/*--------------------------*/
	#define M_BMPSELF    0x2E0
	#define M_BMPGDI     0x2E1
	#define M_PNGGDI     0x2E2
	#define M_JPGGDI     0x2E3
	#define M_ICOSELF    0x2E4
/*--------------------------*/
	#define M_DEBUGIDX   0x2F0
	#define M_ALLTRUE    0x2F1
	#define M_ALLFALSE   0x2F2
	#define M_DUMP       0x2F3
	#define M_IGNORE     0x2F4
/*--------------------------*/
	#define M_IGNOREIDX  0x300
	#define M_CLEAR      0x301
/*--------------------------*/
#define M_PUNEW          0x100
#define M_PUEXP          0x101
#define M_PUPHVW         0x102
#define M_EXE            0x103
#define M_EXERST         0x104
#define M_DESKTOP        0x105
#define M_PICTURE        0x106
#define M_MOVE           0x107
#define M_MOVERST        0x108
#define M_ANALYSE        0x109
#define M_PROPERTY       0x10A
/*--------------------------*/
#define M_WHITE          0x100
#define M_SILVER         0x101
#define M_GRAY           0x102
#define M_SHADOW         0x103
#define M_BLACK          0x104
#define M_FREE           0x105
#define M_AVERAGE        0x106
#define M_POLKA          0x107
#define M_STRIPE         0x108
#define M_CHECK          0x109
/*----------------------------------------------------------------------------*/
#define RGB_WHITE        RGB(0xFF, 0xFF, 0xFF)
#define RGB_GRAY         RGB(0xC0, 0xC0, 0xC0)
#define RGB_BRGRAY       RGB(0xEE, 0xEE, 0xEE)
#define RGB_LTGRAY       RGB(0xCC, 0xCC, 0xCC)
#define RGB_PLGRAY       RGB(0x99, 0x99, 0x99)
#define RGB_DPGRAY       RGB(0x66, 0x66, 0x66)
#define RGB_DKGRAY       RGB(0x33, 0x33, 0x33)
#define RGB_SILVER       RGB(0xE0, 0xE0, 0xE0)
#define RGB_SHADOW       RGB(0x20, 0x20, 0x20)
#define RGB_BLACK        RGB(0x00, 0x00, 0x00)
#define RGB_RED          RGB(0xFF, 0x00, 0x00)
#define RGB_GREEN        RGB(0x00, 0xFF, 0x00)
#define RGB_BLUE         RGB(0x00, 0x00, 0xFF)
#define RGB_MAGENTA      RGB(0xFF, 0x00, 0xFF)
#define RGB_YELLOW       RGB(0xFF, 0xFF, 0x00)
#define RGB_CYAN         RGB(0x00, 0xFF, 0xFF)
#define RGB_CREAM        RGB(0xE4, 0xD3, 0xA2)
#define RGB_DEEPBLUE     RGB(0x4B, 0x64, 0xA1)
#define RGB_SKYBLUE      RGB(0x9B, 0xD1, 0xE8)
#define RGB_SELBLUE      RGB(0x00, 0x78, 0xD7)
/*----------------------------------------------------------------------------*/
#define CNT_FORM         15
#define CNT_ACTIVE       15
#define CNT_DEBUG        40
#define CNT_SKEY         91
#define CNT_FONTFAMILY   25
#define CNT_EXE          4
#define CNT_MOV          10
#define CNT_PAGE         32
#define CNT_ITEM         8
#define CNT_CHIP         7
#define CNT_VERT         50
#define CNT_THUMB        150
/*----------------------------------------------------------------------------*/
#define MAX_IMGW         20000
#define MAX_IMGH         20000
#define MAX_ICOW         255
#define MAX_ICOH         255
/*----------------------------------------------------------------------------*/
#define TBSP_REM         3
#define TBSP_SBF         3
#define TBSP_NSIZE       5
#define TBSP_PRINT       10
#define TBSP_SWAP        5
#define TBSP_AREA        6
#define TBSP_MARGIN      6
#define TBSP_DEFORM      5
#define TBSP_ANGLE       7
#define TBSP_TEXT        14
#define TBSP_LINE        12
#define TBSP_RECT        17
#define TBSP_PEN         5
#define TBSP_FILL        4
#define TBSP_CSV         7
#define TBSP_COPPAT      6
#define TBSP_PAPARA      11
#define TBSP_MVOV        2
#define TBSP_FREE        3
#define TBSP_RGB         3
/*----------------------------------------------------------------------------*/
#define INVALID_ID       99
#define LEN_ANALYZE      10000
/*----------------------------------------------------------------------------*/
#define SZ_WCENTRAL      45
#define SZ_HCENTRAL      16
#define SZ_TOOLBAR0      55
#define SZ_TOOLBAR1      55
#define SZ_TOOLBAR2      25
#define SZ_TOOLBAR3      55
#define SZ_STATBAR       21
#define SZ_WINFO         65
#define SZ_HINFO         17
#define SZ_WEDIT2        186
#define SZ_WEDIT3        266
#define SZ_WPRINT1       309
#define SZ_HPRINT1       32
#define SZ_WPRINT3       350
#define SZ_HPRINT3       115
#define SZ_WPRINT4       160
#define SZ_HPRINT4       115
#define SZ_WCSV1         390
#define SZ_HCSV1         36
#define SZ_WRGBCOLOR     500
#define SZ_HRGBCOLOR     400
#define SZ_RGBRIGHT      110
#define SZ_RGBBOTTOM     76
#define SZ_WANCHOR       50
#define SZ_HANCHOR       40
#define BASE_W           1200  // 800  1920
#define BASE_H           800   // 600  1080  4:3  4:2.5  4:2.25
/*----------------------------------------------------------------------------*/
#define SLIT_DUAL        4
#define SLIT_TRIPLE      4
#define SLIT_QUAD        4
#define SLIT_OCTA        4
#define SLIT_HEXADE      4
#define SLIT_DOTRIA      4
#define MARG_THUMB       8
#define PADD4            4
#define PADD5            5
#define PADD8            8
/*----------------------------------------------------------------------------*/
#define FONT_SIZE10      10
#define FONT_SIZE12      12
#define FONT_SIZE16      16
#define FONT_SIZE20      20
/*----------------------------------------------------------------------------*/
#define BIT_NONE         0x00000001
#define BIT_SUCCESS      0x00000002
#define BIT_FAILURE      0x00000004
#define BIT_NOTEXIST     0x10000000
#define BIT_NOTIMAGE     0x20000000
/*--------------------------------*/
#define BIT_CORE         0x00000001
#define BIT_FORM         0x00000002
#define BIT_CNTN         0x00000004
#define BIT_PICT         0x00000008
#define BIT_TOOL         0x00000010
#define BIT_ITEM         0x00000020
#define BIT_STAT         0x00000040
#define BIT_CHIP         0x00000080
/*--------------------------------*/
#define BIT_HOVER        0x00000001
#define BIT_PUSH         0x00000002
/*--------------------------------*/
#define BIT_NORTH        0x00000001
#define BIT_SOUTH        0x00000002
#define BIT_EAST         0x00000004
#define BIT_WEST         0x00000008
/*--------------------------------*/
#define BIT_XY1          0x00000001
#define BIT_XY2          0x00000002
/*----------------------------------------------------------------------------*/
#define CALLFUNC         LRESULT (CALLBACK *)(HWND,UINT,WPARAM,LPARAM)

/*------------------------------------------------------------------------------
    }N
------------------------------------------------------------------------------*/
#define USER(x1,x2)              SendMessage(x1,  WM_USER,           (WPARAM)x2,  (LPARAM)NULL)
#define COPYDATA(x1,x2)          SendMessage(x1,  WM_COPYDATA,       (WPARAM)NULL,(LPARAM)x2)
#define SETFONT(x1,x2)           SendMessage(x1,  WM_SETFONT,        (WPARAM)x2,  (LPARAM)NULL)
#define SYSCOMMAND(x1,x2)        SendMessage(x1,  WM_SYSCOMMAND,     (WPARAM)x2,  (LPARAM)NULL)
#define VSCROLL(x1,x2)           SendMessage(x1,  WM_VSCROLL,        (WPARAM)x2,  (LPARAM)NULL)
#define NCHITTEST(x1,x2)         SendMessage(x1,  WM_NCHITTEST,      (WPARAM)NULL,(LPARAM)x2)
#define ACTIVATE(x1,x2)          SendMessage(x1,  WM_ACTIVATE,       (WPARAM)x2,  (LPARAM)NULL)
#define CLOSE(x1)                SendMessage(x1,  WM_CLOSE,          (WPARAM)NULL,(LPARAM)NULL)
/*----------------------------------------------------------------------------*/
#define P_USER(x1,x2,x3)         PostMessage(x1,  WM_USER,           (WPARAM)x2,  (LPARAM)x3)
#define P_CLOSE(x1)              PostMessage(x1,  WM_CLOSE,          (WPARAM)NULL,(LPARAM)NULL)
#define P_QUIT()                 PostMessage(NULL,WM_QUIT,           (WPARAM)NULL,(LPARAM)NULL)
/*----------------------------------------------------------------------------*/
#define E_SETFONT(x1,x2)         SendMessage(x1,  WM_SETFONT,        (WPARAM)x2,  (LPARAM)NULL)
#define E_GETTEXTLENGTH(x1)      SendMessage(x1,  WM_GETTEXTLENGTH,  (WPARAM)NULL,(LPARAM)NULL)
#define E_SETLIMITTEXT(x1,x2)    SendMessage(x1,  EM_SETLIMITTEXT,   (WPARAM)x2,  (LPARAM)NULL)
#define E_SETSEL(x1,x2)          SendMessage(x1,  EM_SETSEL,         (WPARAM)NULL,(LPARAM)x2)
/*----------------------------------------------------------------------------*/
#define B_SETFONT(x1,x2)         SendMessage(x1,  WM_SETFONT,        (WPARAM)x2,  (LPARAM)NULL)
#define B_SETCHECK(x1,x2)        SendMessage(x1,  BM_SETCHECK,       (WPARAM)x2,  (LPARAM)NULL)
#define B_GETCHECK(x1)           SendMessage(x1,  BM_GETCHECK,       (WPARAM)NULL,(LPARAM)NULL)
/*----------------------------------------------------------------------------*/
#define C_SETFONT(x1,x2)         SendMessage(x1,  WM_SETFONT,        (WPARAM)x2,  (LPARAM)NULL)
#define C_LIMITTEXT(x1,x2)       SendMessage(x1,  CB_LIMITTEXT,      (WPARAM)x2,  (LPARAM)NULL)
#define C_ADDSTRING(x1,x2)       SendMessage(x1,  CB_ADDSTRING,      (WPARAM)NULL,(LPARAM)x2)
#define C_DELETESTRING(x1)       SendMessage(x1,  CB_DELETESTRING,   (WPARAM)NULL,(LPARAM)NULL)
#define C_SETCURSEL(x1,x2)       SendMessage(x1,  CB_SETCURSEL,      (WPARAM)x2,  (LPARAM)NULL)
#define C_GETCURSEL(x1)          SendMessage(x1,  CB_GETCURSEL,      (WPARAM)NULL,(LPARAM)NULL)
#define C_GETDROPPEDSTATE(x1)    SendMessage(x1,  CB_GETDROPPEDSTATE,(WPARAM)NULL,(LPARAM)NULL)
#define C_GETCOUNT(x1)           SendMessage(x1,  CB_GETCOUNT,       (WPARAM)NULL,(LPARAM)NULL)
/*----------------------------------------------------------------------------*/
#define L_SETFONT(x1,x2)         SendMessage(x1,  WM_SETFONT,        (WPARAM)x2,  (LPARAM)NULL)
#define L_KEYDOWN(x1,x2)         SendMessage(x1,  WM_KEYDOWN,        (WPARAM)x2,  (LPARAM)NULL)
#define L_SETREDRAW(x1,x2)       SendMessage(x1,  WM_SETREDRAW,      (WPARAM)x2,  (LPARAM)NULL)
#define L_ADDSTRING(x1,x2)       SendMessage(x1,  LB_ADDSTRING,      (WPARAM)NULL,(LPARAM)x2)
#define L_DELETESTRING(x1)       SendMessage(x1,  LB_DELETESTRING,   (WPARAM)NULL,(LPARAM)NULL)
#define L_SETCURSEL(x1,x2)       SendMessage(x1,  LB_SETCURSEL,      (WPARAM)x2,  (LPARAM)NULL)
#define L_GETCURSEL(x1)          SendMessage(x1,  LB_GETCURSEL,      (WPARAM)NULL,(LPARAM)NULL)
#define L_SETITEMDATA(x1,x2,x3)  SendMessage(x1,  LB_SETITEMDATA,    (WPARAM)x2,  (LPARAM)x3)
#define L_GETITEMDATA(x1,x2)     SendMessage(x1,  LB_GETITEMDATA,    (WPARAM)x2,  (LPARAM)NULL)
#define L_SELECTSTRING(x1,x2,x3) SendMessage(x1,  LB_SELECTSTRING,   (WPARAM)x2,  (LPARAM)x3)
#define L_GETTEXT(x1,x2,x3)      SendMessage(x1,  LB_GETTEXT,        (WPARAM)x2,  (LPARAM)x3)
#define L_GETCOUNT(x1)           SendMessage(x1,  LB_GETCOUNT,       (WPARAM)NULL,(LPARAM)NULL)
/*----------------------------------------------------------------------------*/
#define TRY(x)   TryZeroDivision(x)
#define TRYD(x)  TryZeroDivisionDouble(x)
/*----------------------------------------------------------------------------*/
#define ABS(x)  abs((double)x)

/*------------------------------------------------------------------------------
    CN[h
------------------------------------------------------------------------------*/
#include "enum.h"
#include "struct.h"
#include "prototype.h"
#include "global.h"
