/*------------------------------------------------------------------------------
    CN[h
------------------------------------------------------------------------------*/
#define CSV_CPP
#include "../common.h"

/*------------------------------------------------------------------------------
    ft@C
------------------------------------------------------------------------------*/
#define CMD_DEFINE  0
#define CMD_TEXT    1
#define CMD_LINE    2
#define CMD_RECT    3
#define CMD_PIXEL   4
#define CMD_MOVETO  5
#define CMD_LINETO  6
#define CMD_FLOOD   7
//--------------------------------
#define LINE_OK     0
#define LINE_EOF    1
#define LINE_OVER   2
#define PARAMS_OK   0
#define PARAMS_NG   1
#define SEP_OK      0
#define SEP_OVCHAR  1
#define SEP_OVPRMS  2
//--------------------------------
#define MAX_CMD     1000
#define MAX_PARAMS  13
#define MAX_DEFINE  400
#define LEN_LINE    500
#define LEN_PARAM   100
#define LEN_SIG     50
#define LEN_VAL     100

/*------------------------------------------------------------------------------
    [Jϐ
------------------------------------------------------------------------------*/
typedef struct Params {
	INT32 cmd;
//--------------------------------------------
	INT32 x;
	INT32 y;
	WCHAR text[LEN_PARAM+1];
	INT32 rgb;
	INT32 back;
	BOOL flgAlpha;
	WCHAR fmy[LEN_PARAM+1];
	INT32 size;
	BOOL flgVert;
//--------------------------------------------
	INT32 x1;
	INT32 y1;
	INT32 x2;
	INT32 y2;
//	INT32 rgb;
	INT32 t;
//--------------------------------------------
//	INT32 x;
//	INT32 y;
	INT32 w;
	INT32 h;
//	INT32 rgb;
//	INT32 back;
//	INT32 t;
	INT32 c;
	BOOL flgFill;
	BOOL flgOnly;
	BOOL flgElip;
	BOOL flgL;
//--------------------------------------------
//	INT32 x;
//	INT32 y;
//	INT32 rgb;
//--------------------------------------------
//	INT32 x;
//	INT32 y;
//	INT32 rgb;
//	INT32 t;
//--------------------------------------------
//	INT32 x;
//	INT32 y;
//--------------------------------------------
//	INT32 x;
//	INT32 y;
//	INT32 rgb;
} Params;

typedef struct Linear {
	WCHAR sig[LEN_SIG+1];
	WCHAR val[LEN_VAL+1];
	Linear *next;
} Linear;

struct {
	INT32 x_0;
	INT32 y_0;
	INT32 x_a;
	INT32 y_a;
	BOOL flgUpdate;
	WCHAR path[MAX_PATH];
	Params prms[MAX_CMD];
	INT32 cntPrms;
	
	Linear root;
	INT32 cntDefine;
	
	HPEN hPn;
	HPEN old;
	INT32 tabStopIdx;
	HWND tabStops[TBSP_CSV];
	
	struct {INT32 x;
			INT32 y;
			INT32 w;
			INT32 h;} cn;
	
	struct {INT32 x;
			INT32 y;
			INT32 w;
			INT32 h;
			UINT32 percent;
			st_Image tmp;} pc;
	
	HWND hWnd;
	HWND hPd[3];
	HWND hEdit[5];
	HWND hBtn[3];
	HWND hCn;
	HWND hPc;
	
	LRESULT (CALLBACK *pCallEdit[5]) (HWND,UINT,WPARAM,LPARAM);
	LRESULT (CALLBACK *pCallBtn [3]) (HWND,UINT,WPARAM,LPARAM);
} cv[CNT_FORM];

/*------------------------------------------------------------------------------
    vg^Cv
------------------------------------------------------------------------------*/
void CvInitClass(void);
void CvInit(LONG);
void CvInitParams(Params *);
void CvInst(LONG);
void CvDialog(LONG);
void CvLoad(LONG);
void CvStore(LONG);
LRESULT CALLBACK CvWndProc      (HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK CvWndProcPd    (HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK CvWndProcEditP (HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK CvWndProcEditX0(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK CvWndProcEditY0(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK CvWndProcEditXA(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK CvWndProcEditYA(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK CvWndProcBtnBrs(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK CvWndProcBtnOk (HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK CvWndProcBtnCan(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK CvWndProcPc    (HWND, UINT, WPARAM, LPARAM);
void CvSetFocus     (LONG, WPARAM, LPARAM);
void CvSize         (LONG, WPARAM, LPARAM);
void CvMinMaxInfo   (LONG, WPARAM, LPARAM);
void CvKeyDown      (LONG, WPARAM, LPARAM, HWND);
void CvKeyDownEnter (LONG, WPARAM, LPARAM, HWND);
void CvKeyDownEsc   (LONG, WPARAM, LPARAM, HWND);
void CvKeyDownTab   (LONG, WPARAM, LPARAM, HWND);
void CvKeyDownF5    (LONG, WPARAM, LPARAM, HWND);
void CvKeyDownUpDw  (LONG, WPARAM, LPARAM, HWND);
void CvClose        (LONG, WPARAM, LPARAM);
void CvDestroy      (LONG, WPARAM, LPARAM);
void CvPdCommand    (LONG, WPARAM, LPARAM);
void CvPdPaint      (LONG, WPARAM, LPARAM);
void CvEdSetFocus   (LONG, WPARAM, LPARAM, HWND);
void CvEdKillFocus  (LONG, WPARAM, LPARAM, HWND);
BOOL CvEdChar       (LONG, WPARAM, LPARAM, HWND);
void CvBtSetFocus   (LONG, WPARAM, LPARAM, HWND);
void CvPcPaint      (LONG, WPARAM, LPARAM);
void CvPcLButtonDown(LONG, WPARAM, LPARAM);
void  CvEnterBrs(LONG);
void  CvEnterOk(LONG);
void  CvEnterCan(LONG);
void  CvUpdate(LONG);
void  CvReadCsv(LONG);
INT32 CvReadCsvLine(HANDLE, ACHAR *, INT32 *, INT32);
INT32 CvReadCsvParams(LONG, WCHAR *, INT32);
INT32 CvReadCsvParamsDefine(LONG, Params *, WCHAR [][LEN_PARAM+1], INT32, INT32);
INT32 CvReadCsvParamsText  (LONG, Params *, WCHAR [][LEN_PARAM+1], INT32, INT32);
INT32 CvReadCsvParamsLine  (LONG, Params *, WCHAR [][LEN_PARAM+1], INT32, INT32);
INT32 CvReadCsvParamsRect  (LONG, Params *, WCHAR [][LEN_PARAM+1], INT32, INT32);
INT32 CvReadCsvParamsPixel (LONG, Params *, WCHAR [][LEN_PARAM+1], INT32, INT32);
INT32 CvReadCsvParamsMoveTo(LONG, Params *, WCHAR [][LEN_PARAM+1], INT32, INT32);
INT32 CvReadCsvParamsLineTo(LONG, Params *, WCHAR [][LEN_PARAM+1], INT32, INT32);
INT32 CvReadCsvParamsFlood (LONG, Params *, WCHAR [][LEN_PARAM+1], INT32, INT32);
INT32 CvSeparate(WCHAR *, WCHAR [][LEN_PARAM+1], INT32 *, INT32);
void  CvRemove(WCHAR *);
void  CvReplace(LONG, WCHAR *);
BOOL  CvCalc(LONG, const WCHAR *const, INT32 *);
BOOL  CvLinearIsExist(LONG, WCHAR *);
void  CvLinearInsert(LONG, WCHAR *, WCHAR *);
void  CvLinearAdd(LONG, Linear *, WCHAR *, WCHAR *);
void  CvLinearDelete(LONG);
void  CvLinearDump(LONG);
void  CvTmpCreate(LONG, INT32, INT32);
void  CvTmpDraw(LONG);
void  CvTmpDrawText(LONG, Params *);
void  CvTmpDrawLine(LONG, Params *);
void  CvTmpDrawRect(LONG, Params *);
void  CvTmpDrawPixel(LONG, Params *);
void  CvTmpDrawMoveto(LONG, Params *);
void  CvTmpDrawLineto(LONG, Params *);
void  CvTmpDrawFlood(LONG, Params *);
void  CvTmpDelete(LONG);
INT32 CvX(LONG, INT32);
INT32 CvY(LONG, INT32);
INT32 CvW(LONG, INT32);
INT32 CvH(LONG, INT32);
void  CvImageView(LONG);
void  CvSetPane(LONG);

/*------------------------------------------------------------------------------
    Fvoid CvInitClass(void)
    @\FEBhE̐݌v}o^
------------------------------------------------------------------------------*/
void CvInitClass(void)
{
	WNDCLASS wcCsv;
	WNDCLASS wcCsvPd;
	WNDCLASS wcCsvCn;
	WNDCLASS wcCsvPc;
	
	InitWC(CS_OWNDC, DefWindowProc, hIcon,hCurArrow,hBrBrGray,NM_CSV,  &wcCsv);
	InitWC(CS_OWNDC, DefWindowProc, NULL, hCurArrow,hBrWhite, NM_CSVPD,&wcCsvPd);
	InitWC(CS_OWNDC, DefWindowProc, NULL, hCurArrow,hBrWhite, NM_CSVCN,&wcCsvCn);
	InitWC(CS_OWNDC, DefWindowProc, NULL, hCurArrow,hBrNull,  NM_CSVPC,&wcCsvPc);
	
	RegisterClass(&wcCsv);
	RegisterClass(&wcCsvPd);
	RegisterClass(&wcCsvCn);
	RegisterClass(&wcCsvPc);
}

/*------------------------------------------------------------------------------
    Fvoid CvInit(LONG)
    FLONG    FORM ID
    @\F
------------------------------------------------------------------------------*/
void CvInit(LONG id)
{
	INT32 i;
	
	cv[id].x_0       = 0;
	cv[id].y_0       = 0;
	cv[id].x_a       = 1000;
	cv[id].y_a       = 1000;
	cv[id].flgUpdate = FALSE;
	a_memset(cv[id].path, MAX_PATH);
	
	for (i = 0; i < MAX_CMD; i++) {CvInitParams(&cv[id].prms[i]);}
	cv[id].cntPrms = 0;
	
	a_memset(cv[id].root.sig, LEN_SIG+1);
	a_memset(cv[id].root.val, LEN_VAL+1);
	cv[id].root.next = NULL;
	
	cv[id].cntDefine = 0;
	
	cv[id].hPn = NULL;
	cv[id].old = NULL;
	
	cv[id].tabStopIdx = 0;
	for (i = 0; i < TBSP_CSV; i++) {cv[id].tabStops[i] = NULL;}
	
	cv[id].cn.x = 0;
	cv[id].cn.y = 0;
	cv[id].cn.w = 0;
	cv[id].cn.h = 0;
	
	cv[id].pc.x = 0;
	cv[id].pc.y = 0;
	cv[id].pc.w = 0;
	cv[id].pc.h = 0;
	InitImg(&cv[id].pc.tmp);
	
	cv[id].hWnd = NULL;
	for (i = 0; i < 3; i++) {cv[id].hPd  [i] = NULL;}
	for (i = 0; i < 5; i++) {cv[id].hEdit[i] = NULL;}
	for (i = 0; i < 3; i++) {cv[id].hBtn [i] = NULL;}
	cv[id].hCn = NULL;
	cv[id].hPc = NULL;
}

/*------------------------------------------------------------------------------
    Fvoid CvInitParams(Params *)
    FParams *    -
    @\Fp[^
------------------------------------------------------------------------------*/
void CvInitParams(Params *pPrms)
{
	pPrms->cmd = CMD_DEFINE;
	
	pPrms->x = 0;
	pPrms->y = 0;
	a_memset(pPrms->text, LEN_PARAM+1);
	pPrms->rgb      = 0x000000;
	pPrms->back     = 0x000000;
	pPrms->flgAlpha = FALSE;
	a_memset(pPrms->fmy, 25);
	pPrms->size    = 0;
	pPrms->flgVert = FALSE;
	
	pPrms->x1  = 0;
	pPrms->y1  = 0;
	pPrms->x2  = 0;
	pPrms->y2  = 0;
//	pPrms->rgb = 0x000000;
	pPrms->t   = 0;
	
//	pPrms->x       = 0;
//	pPrms->y       = 0;
	pPrms->w       = 0;
	pPrms->h       = 0;
//	pPrms->rgb     = 0x000000;
//	pPrms->back    = 0x000000;
//	pPrms->t       = 0;
	pPrms->c       = 0;
	pPrms->flgFill = FALSE;
	pPrms->flgOnly = FALSE;
	pPrms->flgElip = FALSE;
	pPrms->flgL    = FALSE;
	
//	pPrms->x   = 0;
//	pPrms->y   = 0;
//	pPrms->rgb = 0x000000;
}

/*------------------------------------------------------------------------------
    Fvoid CvInst(LONG)
    FLONG    FORM ID
    @\F̉
------------------------------------------------------------------------------*/
void CvInst(LONG id)
{
	DWORD styleCv  = WS_OVERLAPPED|WS_CAPTION|WS_MAXIMIZEBOX|WS_THICKFRAME|WS_SYSMENU;
	DWORD stylePd1 = WS_CHILD|WS_VISIBLE;
	DWORD stylePd2 = WS_CHILD|WS_VISIBLE;
	DWORD stylePd3 = WS_CHILD;
	DWORD styleEd1 = WS_CHILD|WS_VISIBLE|WS_BORDER|ES_LEFT|  ES_AUTOHSCROLL;
	DWORD styleEd2 = WS_CHILD|WS_VISIBLE|WS_BORDER|ES_CENTER|ES_AUTOHSCROLL;
	DWORD styleCk  = WS_CHILD|WS_VISIBLE|BS_AUTOCHECKBOX;
	DWORD styleBt  = WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON;
	DWORD styleCn  = WS_CHILD|WS_CLIPCHILDREN;
	DWORD stylePc  = WS_CHILD;
	INT32 x[4] = {61,61,61,61,};
	INT32 y[4] = {12,42,72,102,};
	INT32 wPd1;
	INT32 hPd1;
	INT32 yPd2;
	INT32 wPd2;
	
	wPd1 = SZ_WCSV1;
	hPd1 = SZ_HCSV1;
	yPd2 = SZ_HCSV1+PADD8*2;
	wPd2 = SZ_WEDIT2-PADD8*2;
	cv[id].hWnd     = a_CreateWindow(NM_CSV,   TxTl(E_TTLCSV),styleCv, 0,   0,   0,   0,   fm[id].hWnd);
	cv[id].hPd[0]   = a_CreateWindow(NM_CSVPD, NULL,          stylePd1,8,   8,   wPd1,hPd1,cv[id].hWnd);
	cv[id].hPd[1]   = a_CreateWindow(NM_CSVPD, NULL,          stylePd2,8,   yPd2,wPd2,164, cv[id].hWnd);
	cv[id].hPd[2]   = a_CreateWindow(NM_CSVPD, NULL,          stylePd3,0,   0,   0,   0,   cv[id].hWnd);
	cv[id].hEdit[0] = a_CreateWindow(L"Edit",  cv[id].path,   styleEd1,7,   8,   300, 20,  cv[id].hPd[0]);
	cv[id].hEdit[1] = a_CreateWindow(L"Edit",  L"0",          styleEd2,x[0],y[0],65,  17,  cv[id].hPd[1]);
	cv[id].hEdit[2] = a_CreateWindow(L"Edit",  L"0",          styleEd2,x[1],y[1],65,  17,  cv[id].hPd[1]);
	cv[id].hEdit[3] = a_CreateWindow(L"Edit",  L"1000",       styleEd2,x[2],y[2],65,  17,  cv[id].hPd[1]);
	cv[id].hEdit[4] = a_CreateWindow(L"Edit",  L"1000",       styleEd2,x[3],y[3],65,  17,  cv[id].hPd[1]);
	cv[id].hBtn[0]  = a_CreateWindow(L"Button",L"browse",     styleBt, 314, 5,   70,  25,  cv[id].hPd[0]);
	cv[id].hBtn[1]  = a_CreateWindow(L"Button",TxEd(E_OK),    styleBt, 10,  131, 70,  25,  cv[id].hPd[1]);
	cv[id].hBtn[2]  = a_CreateWindow(L"Button",TxEd(E_CANCEL),styleBt, 90,  131, 70,  25,  cv[id].hPd[1]);
	cv[id].hCn      = a_CreateWindow(NM_CSVCN, NULL,          styleCn, 0,   0,   0,   0,   cv[id].hPd[2]);
	cv[id].hPc      = a_CreateWindow(NM_CSVPC, NULL,          stylePc, 0,   0,   0,   0,   cv[id].hCn);
	
	SetWindowLong(cv[id].hWnd,    GWL_USERDATA, id);
	SetWindowLong(cv[id].hPd[0],  GWL_USERDATA, 0*100+id);
	SetWindowLong(cv[id].hPd[1],  GWL_USERDATA, 1*100+id);
	SetWindowLong(cv[id].hPd[2],  GWL_USERDATA, 2*100+id);
	SetWindowLong(cv[id].hEdit[0],GWL_USERDATA, 0*100+id);
	SetWindowLong(cv[id].hEdit[1],GWL_USERDATA, 1*100+id);
	SetWindowLong(cv[id].hEdit[2],GWL_USERDATA, 2*100+id);
	SetWindowLong(cv[id].hEdit[3],GWL_USERDATA, 3*100+id);
	SetWindowLong(cv[id].hEdit[4],GWL_USERDATA, 4*100+id);
	SetWindowLong(cv[id].hBtn[0] ,GWL_USERDATA, 0*100+id);
	SetWindowLong(cv[id].hBtn[1] ,GWL_USERDATA, 1*100+id);
	SetWindowLong(cv[id].hBtn[2] ,GWL_USERDATA, 2*100+id);
	SetWindowLong(cv[id].hPc,     GWL_USERDATA, id);
	
	SetWindowLong(cv[id].hWnd,  GWL_WNDPROC, (LONG)CvWndProc);
	SetWindowLong(cv[id].hPd[0],GWL_WNDPROC, (LONG)CvWndProcPd);
	SetWindowLong(cv[id].hPd[1],GWL_WNDPROC, (LONG)CvWndProcPd);
	SetWindowLong(cv[id].hPd[2],GWL_WNDPROC, (LONG)CvWndProcPd);
	SetWindowLong(cv[id].hPc,   GWL_WNDPROC, (LONG)CvWndProcPc);
	
	E_SETFONT(cv[id].hEdit[0], hFtArial14);
	E_SETFONT(cv[id].hEdit[1], hFtCourier);
	E_SETFONT(cv[id].hEdit[2], hFtCourier);
	E_SETFONT(cv[id].hEdit[3], hFtCourier);
	E_SETFONT(cv[id].hEdit[4], hFtCourier);
	B_SETFONT(cv[id].hBtn [0], hFtArial14);
	B_SETFONT(cv[id].hBtn [1], hFtArial14);
	B_SETFONT(cv[id].hBtn [2], hFtArial14);
	
	E_SETLIMITTEXT(cv[id].hEdit[1], 5);
	E_SETLIMITTEXT(cv[id].hEdit[2], 5);
	E_SETLIMITTEXT(cv[id].hEdit[3], 4);
	E_SETLIMITTEXT(cv[id].hEdit[4], 4);
	
	EnableWindow(cv[id].hEdit[0], FALSE);
	
	cv[id].pCallEdit[0] = (CALLFUNC)GetWindowLong(cv[id].hEdit[0], GWL_WNDPROC);
	cv[id].pCallEdit[1] = (CALLFUNC)GetWindowLong(cv[id].hEdit[1], GWL_WNDPROC);
	cv[id].pCallEdit[2] = (CALLFUNC)GetWindowLong(cv[id].hEdit[2], GWL_WNDPROC);
	cv[id].pCallEdit[3] = (CALLFUNC)GetWindowLong(cv[id].hEdit[3], GWL_WNDPROC);
	cv[id].pCallEdit[4] = (CALLFUNC)GetWindowLong(cv[id].hEdit[4], GWL_WNDPROC);
	cv[id].pCallBtn [0] = (CALLFUNC)GetWindowLong(cv[id].hBtn [0], GWL_WNDPROC);
	cv[id].pCallBtn [1] = (CALLFUNC)GetWindowLong(cv[id].hBtn [1], GWL_WNDPROC);
	cv[id].pCallBtn [2] = (CALLFUNC)GetWindowLong(cv[id].hBtn [2], GWL_WNDPROC);
	SetWindowLong(cv[id].hEdit[0], GWL_WNDPROC, (LONG)CvWndProcEditP);
	SetWindowLong(cv[id].hEdit[1], GWL_WNDPROC, (LONG)CvWndProcEditX0);
	SetWindowLong(cv[id].hEdit[2], GWL_WNDPROC, (LONG)CvWndProcEditY0);
	SetWindowLong(cv[id].hEdit[3], GWL_WNDPROC, (LONG)CvWndProcEditXA);
	SetWindowLong(cv[id].hEdit[4], GWL_WNDPROC, (LONG)CvWndProcEditYA);
	SetWindowLong(cv[id].hBtn [0], GWL_WNDPROC, (LONG)CvWndProcBtnBrs);
	SetWindowLong(cv[id].hBtn [1], GWL_WNDPROC, (LONG)CvWndProcBtnOk);
	SetWindowLong(cv[id].hBtn [2], GWL_WNDPROC, (LONG)CvWndProcBtnCan);
	
	cv[id].tabStopIdx = 0;
	cv[id].tabStops[0] = cv[id].hBtn[0];
	cv[id].tabStops[1] = cv[id].hEdit[1];
	cv[id].tabStops[2] = cv[id].hEdit[2];
	cv[id].tabStops[3] = cv[id].hEdit[3];
	cv[id].tabStops[4] = cv[id].hEdit[4];
	cv[id].tabStops[5] = cv[id].hBtn[1];
	cv[id].tabStops[6] = cv[id].hBtn[2];
	
	SetFocus(cv[id].hEdit[1]);
}

/*------------------------------------------------------------------------------
    Fvoid CvDialog(LONG)
    FLONG    FORM ID
    @\F_CAO
------------------------------------------------------------------------------*/
void CvDialog(LONG id)
{
	CvInit(id);
	CvLoad(id);
	
	CvTmpCreate(id, fm[id].pc[0].img.w, fm[id].pc[0].img.h);
	CvInst(id);
	
	CvReadCsv(id);
	CvTmpDraw(id);
	PpPlacement(id, cv[id].hWnd);
	
	EnableWindow(fm[id].hWnd, FALSE);
	fm[id].hModal = cv[id].hWnd;
	
	ShowWindow(cv[id].hPd[2], 0x1);
	ShowWindow(cv[id].hCn,    0x1);
	ShowWindow(cv[id].hPc,    0x1);
	
	MessageLoop();
}

/*------------------------------------------------------------------------------
    Fvoid CvLoad(LONG)
    FLONG    FORM ID
    @\FO[of[^ǂݍ
------------------------------------------------------------------------------*/
void CvLoad(LONG id)
{
	wcscpy(cv[id].path, g_cvPath);
}

/*------------------------------------------------------------------------------
    Fvoid CvStore(LONG)
    FLONG    FORM ID
    @\FO[of[^XV
------------------------------------------------------------------------------*/
void CvStore(LONG id)
{
	wcscpy(g_cvPath, cv[id].path);
}

/*------------------------------------------------------------------------------
    FLRESULT CALLBACK CvWndProc(...)
    F-
    ߒlF-
    @\FCSVCxg
------------------------------------------------------------------------------*/
LRESULT CALLBACK CvWndProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp)
{
	LONG id;
	
	id = GetWindowLong(hWnd, GWL_USERDATA);
	
	switch (msg) {
	case WM_SETFOCUS:       CvSetFocus     (id, wp, lp);  break;
	case WM_SIZE:           CvSize         (id, wp, lp);  break;
	case WM_GETMINMAXINFO:  CvMinMaxInfo(id, wp, lp);  break;
	case WM_CLOSE:          CvClose        (id, wp, lp);  break;
	case WM_DESTROY:        CvDestroy      (id, wp, lp);  break;
	default:  break;
	}
	return DefWindowProc(hWnd, msg, wp, lp);
}

/*------------------------------------------------------------------------------
    FLRESULT CALLBACK CvWndProcPd(...)
    F-
    ߒlF-
    @\FPDCxg
------------------------------------------------------------------------------*/
LRESULT CALLBACK CvWndProcPd(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp)
{
	LONG tmp;
	LONG id;
	LONG idP;
	
	tmp = GetWindowLong(hWnd, GWL_USERDATA);
	id  = tmp % 100;
	idP = tmp / 100;
	
	switch (msg) {
	case WM_COMMAND:
		if ((idP == 0) || (idP == 1)) {
			CvPdCommand(id, wp, lp);
		}
		break;
	case WM_PAINT:
		if (idP == 1) {
			CvPdPaint(id, wp, lp);
		}
		break;
	default:  break;
	}
	
	return DefWindowProc(hWnd, msg, wp, lp);
}

/*------------------------------------------------------------------------------
    FLRESULT CALLBACK CvWndProcEditP(...)
    F-
    ߒlF-
    @\FEDIT PCxg
------------------------------------------------------------------------------*/
LRESULT CALLBACK CvWndProcEditP(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp)
{
	LONG tmp;
	LONG id;
	LONG idE;
	
	tmp = GetWindowLong(hWnd, GWL_USERDATA);
	id  = tmp % 100;
	idE = tmp / 100;
	
	switch (msg) {
	default: break;
	}
	return cv[id].pCallEdit[idE](hWnd, msg, wp, lp);
}

/*------------------------------------------------------------------------------
    FLRESULT CALLBACK CvWndProcEditX0(...)
    F-
    ߒlF-
    @\FEDIT X0Cxg
------------------------------------------------------------------------------*/
LRESULT CALLBACK CvWndProcEditX0(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp)
{
	LONG tmp;
	LONG id;
	LONG idE;
	
	tmp = GetWindowLong(hWnd, GWL_USERDATA);
	id  = tmp % 100;
	idE = tmp / 100;
	
	switch (msg) {
	case WM_SETFOCUS:   CvEdSetFocus (id, wp, lp, hWnd);  break;
	case WM_KILLFOCUS:  CvEdKillFocus(id, wp, lp, hWnd);  break;
	case WM_KEYDOWN:
		CvKeyDown(id, wp, lp, hWnd);
		if (wp == KEY_UP) {return 0;}
		if (wp == KEY_DW) {return 0;}
		break;
	case WM_CHAR:
		if (CvEdChar(id, wp, lp, hWnd) == FALSE) {return 0;}
		break;
	default:
		break;
	}
	return cv[id].pCallEdit[idE](hWnd, msg, wp, lp);
}

/*------------------------------------------------------------------------------
    FLRESULT CALLBACK CvWndProcEditY0(...)
    F-
    ߒlF-
    @\FEDIT Y0Cxg
------------------------------------------------------------------------------*/
LRESULT CALLBACK CvWndProcEditY0(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp)
{
	LONG tmp;
	LONG id;
	LONG idE;
	
	tmp = GetWindowLong(hWnd, GWL_USERDATA);
	id  = tmp % 100;
	idE = tmp / 100;
	
	switch (msg) {
	case WM_SETFOCUS:   CvEdSetFocus (id, wp, lp, hWnd);  break;
	case WM_KILLFOCUS:  CvEdKillFocus(id, wp, lp, hWnd);  break;
	case WM_KEYDOWN:
		CvKeyDown(id, wp, lp, hWnd);
		if (wp == KEY_UP) {return 0;}
		if (wp == KEY_DW) {return 0;}
		break;
	case WM_CHAR:
		if (CvEdChar(id, wp, lp, hWnd) == FALSE) {return 0;}
		break;
	default:
		break;
	}
	return cv[id].pCallEdit[idE](hWnd, msg, wp, lp);
}

/*------------------------------------------------------------------------------
    FLRESULT CALLBACK CvWndProcEditXA(...)
    F-
    ߒlF-
    @\FEDIT XACxg
------------------------------------------------------------------------------*/
LRESULT CALLBACK CvWndProcEditXA(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp)
{
	LONG tmp;
	LONG id;
	LONG idE;
	
	tmp = GetWindowLong(hWnd, GWL_USERDATA);
	id  = tmp % 100;
	idE = tmp / 100;
	
	switch (msg) {
	case WM_SETFOCUS:   CvEdSetFocus (id, wp, lp, hWnd);  break;
	case WM_KILLFOCUS:  CvEdKillFocus(id, wp, lp, hWnd);  break;
	case WM_KEYDOWN:
		CvKeyDown(id, wp, lp, hWnd);
		if (wp == KEY_UP) {return 0;}
		if (wp == KEY_DW) {return 0;}
		break;
	case WM_CHAR:
		if (CvEdChar(id, wp, lp, hWnd) == FALSE) {return 0;}
		break;
	default:
		break;
	}
	return cv[id].pCallEdit[idE](hWnd, msg, wp, lp);
}

/*------------------------------------------------------------------------------
    FLRESULT CALLBACK CvWndProcEditYA(...)
    F-
    ߒlF-
    @\FEDIT YACxg
------------------------------------------------------------------------------*/
LRESULT CALLBACK CvWndProcEditYA(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp)
{
	LONG tmp;
	LONG id;
	LONG idE;
	
	tmp = GetWindowLong(hWnd, GWL_USERDATA);
	id  = tmp % 100;
	idE = tmp / 100;
	
	switch (msg) {
	case WM_SETFOCUS:   CvEdSetFocus (id, wp, lp, hWnd);  break;
	case WM_KILLFOCUS:  CvEdKillFocus(id, wp, lp, hWnd);  break;
	case WM_KEYDOWN:
		CvKeyDown(id, wp, lp, hWnd);
		if (wp == KEY_UP) {return 0;}
		if (wp == KEY_DW) {return 0;}
		break;
	case WM_CHAR:
		if (CvEdChar(id, wp, lp, hWnd) == FALSE) {return 0;}
		break;
	default:
		break;
	}
	return cv[id].pCallEdit[idE](hWnd, msg, wp, lp);
}

/*------------------------------------------------------------------------------
    FLRESULT CALLBACK CvWndProcBtnBrs(...)
    F-
    ߒlF-
    @\FBTN BRSCxg
------------------------------------------------------------------------------*/
LRESULT CALLBACK CvWndProcBtnBrs(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp)
{
	LONG tmp;
	LONG id;
	LONG idB;
	
	tmp = GetWindowLong(hWnd, GWL_USERDATA);
	id  = tmp % 100;
	idB = tmp / 100;
	
	switch (msg) {
	case WM_SETFOCUS:  CvBtSetFocus(id, wp, lp, hWnd);  break;
	case WM_KEYDOWN:   CvKeyDown   (id, wp, lp, hWnd);  break;
	default: break;
	}
	return cv[id].pCallBtn[idB](hWnd, msg, wp, lp);
}

/*------------------------------------------------------------------------------
    FLRESULT CALLBACK CvWndProcBtnOk(...)
    F-
    ߒlF-
    @\FBTN OKCxg
------------------------------------------------------------------------------*/
LRESULT CALLBACK CvWndProcBtnOk(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp)
{
	LONG tmp;
	LONG id;
	LONG idB;
	
	tmp = GetWindowLong(hWnd, GWL_USERDATA);
	id  = tmp % 100;
	idB = tmp / 100;
	
	switch (msg) {
	case WM_SETFOCUS:  CvBtSetFocus(id, wp, lp, hWnd);  break;
	case WM_KEYDOWN:   CvKeyDown   (id, wp, lp, hWnd);  break;
	default: break;
	}
	return cv[id].pCallBtn[idB](hWnd, msg, wp, lp);
}

/*------------------------------------------------------------------------------
    FLRESULT CALLBACK CvWndProcBtnCan(...)
    F-
    ߒlF-
    @\FBTN CANCELCxg
------------------------------------------------------------------------------*/
LRESULT CALLBACK CvWndProcBtnCan(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp)
{
	LONG tmp;
	LONG id;
	LONG idB;
	
	tmp = GetWindowLong(hWnd, GWL_USERDATA);
	id  = tmp % 100;
	idB = tmp / 100;
	
	switch (msg) {
	case WM_SETFOCUS:  CvBtSetFocus(id, wp, lp, hWnd);  break;
	case WM_KEYDOWN:   CvKeyDown   (id, wp, lp, hWnd);  break;
	default: break;
	}
	return cv[id].pCallBtn[idB](hWnd, msg, wp, lp);
}

/*------------------------------------------------------------------------------
    FLRESULT CALLBACK CvWndProcPc(...)
    F-
    ߒlF-
    @\FPCCxg
------------------------------------------------------------------------------*/
LRESULT CALLBACK CvWndProcPc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp)
{
	LONG id;
	
	id = GetWindowLong(hWnd, GWL_USERDATA);
	
	switch (msg) {
	case WM_PAINT:        CvPcPaint      (id, wp, lp);  break;
	case WM_LBUTTONDOWN:  CvPcLButtonDown(id, wp, lp);  break;
	default: break;
	}
	return DefWindowProc(hWnd, msg, wp, lp);
}

/*------------------------------------------------------------------------------
    Fvoid CvSetFocus(LONG, WPARAM, LPARAM)
    FLONG    FORM ID
          WPARAM  -
          LPARAM  -
    @\FCSV WM_SETFOCUSCxg
------------------------------------------------------------------------------*/
void CvSetFocus(LONG id, WPARAM wp, LPARAM lp)
{
	SetFocus(cv[id].tabStops[cv[id].tabStopIdx]);
}

/*------------------------------------------------------------------------------
    Fvoid CvSize(LONG, WPARAM, LPARAM)
    FLONG    FORM ID
          WPARAM  -
          LPARAM  -
    @\FCSV WM_SIZECxg
------------------------------------------------------------------------------*/
void CvSize(LONG id, WPARAM wp, LPARAM lp)
{
	RECT rc;
	INT32 w;
	INT32 h;
	
	if (fm[id].cntSkipEdit != 0) {fm[id].cntSkipEdit--;  return;}
	
	GetClientRect(cv[id].hWnd, &rc);
	w = rc.right - rc.left;
	h = rc.bottom - rc.top;
	
	a_SetWindowPos(cv[id].hPd[2], SZ_WEDIT2,
								  SZ_HCSV1+PADD8*2,
								  w-SZ_WEDIT2-PADD8,
								  h-SZ_HCSV1-PADD8*3);
	
	CvSetPane(id);
	CvImageView(id);
	
	a_SetWindowPos(cv[id].hPc, cv[id].pc.x, cv[id].pc.y,
							   cv[id].pc.w, cv[id].pc.h);
	
	InvalidateRect(cv[id].hWnd,   NULL, TRUE);
	InvalidateRect(cv[id].hPd[2], NULL, TRUE);
	InvalidateRect(cv[id].hCn,    NULL, TRUE);
	InvalidateRect(cv[id].hPc,    NULL, FALSE);
	UpdateWindow(cv[id].hWnd);
	UpdateWindow(cv[id].hPd[2]);
	UpdateWindow(cv[id].hCn);
	UpdateWindow(cv[id].hPc);
}

/*------------------------------------------------------------------------------
    Fvoid CvMinMaxInfo(LONG, WPARAM, LPARAM)
    FLONG    FORM ID
          WPARAM  -
          LPARAM  -
    @\FCSV WM_GETMINMAXINFOCxg
------------------------------------------------------------------------------*/
void CvMinMaxInfo(LONG id, WPARAM wp, LPARAM lp)
{
	MINMAXINFO *mmi;
	INT32 w;
	INT32 h;
	
	w = SZ_WCSV1+    PADD8*2+GetSystemMetrics(SM_CYSIZEFRAME)*2;
	h = 164+SZ_HCSV1+PADD8*3+GetSystemMetrics(SM_CYSIZEFRAME)*2+GetSystemMetrics(SM_CYCAPTION);
	
	mmi = (MINMAXINFO *)lp;
	mmi->ptMinTrackSize.x = w;
	mmi->ptMinTrackSize.y = h;
}

/*------------------------------------------------------------------------------
    Fvoid CvKeyDown(LONG, WPARAM, LPARAM, HWND)
    FLONG    FORM ID
          WPARAM  -
          LPARAM  -
          HWND    -
    @\FCSV WM_KEYDOWNCxg
------------------------------------------------------------------------------*/
void CvKeyDown(LONG id, WPARAM wp, LPARAM lp, HWND hWnd)
{
	switch (wp) {
	case KEY_ENTER:  CvKeyDownEnter(id, wp, lp, hWnd);  break;
	case KEY_ESC:    CvKeyDownEsc  (id, wp, lp, hWnd);  break;
	case KEY_TAB:    CvKeyDownTab  (id, wp, lp, hWnd);  break;
	case KEY_F5:     CvKeyDownF5   (id, wp, lp, hWnd);  break;
	case KEY_UP:
	case KEY_DW:     CvKeyDownUpDw (id, wp, lp, hWnd);  break;
	default: break;
	}
}

/*------------------------------------------------------------------------------
    Fvoid CvKeyDownEnter(LONG, WPARAM, LPARAM, HWND)
    FLONG    FORM ID
          WPARAM  -
          LPARAM  -
          HWND    -
    @\FCSV [enter]L[Cxg
------------------------------------------------------------------------------*/
void CvKeyDownEnter(LONG id, WPARAM wp, LPARAM lp, HWND hWnd)
{
	if      (hWnd == cv[id].hBtn[0]) {CvEnterBrs(id);}
	else if (hWnd == cv[id].hBtn[2]) {CvEnterCan(id);}
	else                             {CvEnterOk (id);}
}

/*------------------------------------------------------------------------------
    Fvoid CvKeyDownEsc(LONG, WPARAM, LPARAM, HWND)
    FLONG    FORM ID
          WPARAM  -
          LPARAM  -
          HWND    -
    @\FCSV [esc]L[Cxg
------------------------------------------------------------------------------*/
void CvKeyDownEsc(LONG id, WPARAM wp, LPARAM lp, HWND hWnd)
{
	CLOSE(cv[id].hWnd);
}

/*------------------------------------------------------------------------------
    Fvoid CvKeyDownTab(LONG, WPARAM, LPARAM, HWND)
    FLONG    FORM ID
          WPARAM  -
          LPARAM  -
          HWND    -
    @\FCSV [tab]L[Cxg
------------------------------------------------------------------------------*/
void CvKeyDownTab(LONG id, WPARAM wp, LPARAM lp, HWND hWnd)
{
	BOOL shift;
	
	if ((GetKeyState(KEY_SHIFT) & 0x80) != 0) {shift = TRUE;}
	else                                      {shift = FALSE;}
	
	if (shift == TRUE) {
		if (cv[id].tabStopIdx == 0) {cv[id].tabStopIdx = TBSP_CSV-1;}
		else                        {cv[id].tabStopIdx--;}
	}
	else {
		cv[id].tabStopIdx = (cv[id].tabStopIdx + 1) % TBSP_CSV;
	}
	SetFocus(cv[id].tabStops[cv[id].tabStopIdx]);
}

/*------------------------------------------------------------------------------
    Fvoid CvKeyDownF5(LONG, WPARAM, LPARAM, HWND)
    FLONG    FORM ID
          WPARAM  -
          LPARAM  -
          HWND    -
    @\FCSV [F5]L[Cxg
------------------------------------------------------------------------------*/
void CvKeyDownF5(LONG id, WPARAM wp, LPARAM lp, HWND hWnd)
{
	CvReadCsv(id);
	CvTmpDraw(id);
	InvalidateRect(cv[id].hPc, NULL, FALSE);
	UpdateWindow  (cv[id].hPc);
}

/*------------------------------------------------------------------------------
    Fvoid CvKeyDownUpDw(LONG, WPARAM, LPARAM, HWND)
    FLONG    FORM ID
          WPARAM  -
          LPARAM  -
          HWND    -
    @\FCSV [][]L[Cxg
------------------------------------------------------------------------------*/
void CvKeyDownUpDw(LONG id, WPARAM wp, LPARAM lp, HWND hWnd)
{
	INT16 tmp;
	UINT16 comb;
	BOOL shift;
	INT32 step;
	WCHAR text[5+1];
	INT32 val;
	INT32 limL;
	INT32 limH;
	
	comb  = 0x000;
	shift = FALSE;
	tmp = GetKeyState(KEY_CTRL);   if((tmp & 0x80)!=0){comb |= 0x100;}
	tmp = GetKeyState(KEY_SHIFT);  if((tmp & 0x80)!=0){comb |= 0x010;  shift = TRUE;}
	
	if ((hWnd != cv[id].hEdit[1]) &&
		(hWnd != cv[id].hEdit[2]) &&
		(hWnd != cv[id].hEdit[3]) &&
		(hWnd != cv[id].hEdit[4]))
	{
		return;
	}
	
	if      (comb == 0x000) {step = 1;}
	else if (comb == 0x100) {step = 10;}
	else if (comb == 0x010) {step = 100;}
	else                    {return;}
	
	GetWindowText(hWnd, text, 5+1);
	val = _wtoi(text);
	
	if      (hWnd == cv[id].hEdit[1]) {limL = -9999;  limH = 9999;}
	else if (hWnd == cv[id].hEdit[2]) {limL = -9999;  limH = 9999;}
	else if (hWnd == cv[id].hEdit[3]) {limL = 0;      limH = 9999;}
	else if (hWnd == cv[id].hEdit[4]) {limL = 0;      limH = 9999;}
	
	if (wp == KEY_UP) {val += step;}
	else              {val -= step;}
	
	if (val < limL) {val = limL;}
	if (limH < val) {val = limH;}
	
	_itow(val, text, 10);
	SetWindowText(hWnd, text);
	EditSelAll(hWnd);
	CvUpdate(id);
}

/*------------------------------------------------------------------------------
    Fvoid CvClose(LONG, WPARAM, LPARAM)
    FLONG    FORM ID
          WPARAM  -
          LPARAM  -
    @\FCSV WM_CLOSECxg
------------------------------------------------------------------------------*/
void CvClose(LONG id, WPARAM wp, LPARAM lp)
{
	fm[id].hModal = NULL;
	EnableWindow(fm[id].hWnd, TRUE);
	SetForegroundWindow(fm[id].hWnd);
}

/*------------------------------------------------------------------------------
    Fvoid CvDestroy(LONG, WPARAM, LPARAM)
    FLONG    FORM ID
          WPARAM  -
          LPARAM  -
    @\FCSV WM_DESTROYCxg
------------------------------------------------------------------------------*/
void CvDestroy(LONG id, WPARAM wp, LPARAM lp)
{
	if ((cv[id].hPn != NULL) && (cv[id].old != NULL)) {
		SelectObject(cv[id].pc.tmp.hdc, cv[id].old);
		DeleteObject(cv[id].hPn);
	}
	
	CvTmpDelete(id);
	CvLinearDelete(id);
	P_QUIT();
}

/*------------------------------------------------------------------------------
    Fvoid CvPdCommand(LONG, WPARAM, LPARAM)
    FLONG    FORM ID
          WPARAM  -
          LPARAM  -
    @\FCSV WM_COMMANDCxg
------------------------------------------------------------------------------*/
void CvPdCommand(LONG id, WPARAM wp, LPARAM lp)
{
	if (HIWORD(wp) != BN_CLICKED) {return;}
	
	if      ((HWND)lp == cv[id].hBtn[0]) {CvEnterBrs(id);}
	else if ((HWND)lp == cv[id].hBtn[1]) {CvEnterOk (id);}
	else if ((HWND)lp == cv[id].hBtn[2]) {CvEnterCan(id);}
}

/*------------------------------------------------------------------------------
    Fvoid CvPdPaint(LONG, WPARAM, LPARAM)
    FLONG    FORM ID
          WPARAM  -
          LPARAM  -
    @\FPD WM_PAINTCxg
------------------------------------------------------------------------------*/
void CvPdPaint(LONG id, WPARAM wp, LPARAM lp)
{
	HDC hdc;
	PAINTSTRUCT ps;
	RECT rc;
	
	hdc = BeginPaint(cv[id].hPd[1], &ps);
	GetClientRect(cv[id].hPd[1], &rc);
	SetClipRgn(hdc, &rc);
	
	SelectObject(hdc, hFtArial14);
	
	SetBkMode(hdc, TRANSPARENT);
	SetTextColor(hdc, RGB_DPGRAY);
	
	a_TextOut(hdc, 37, 13,  L"X0");
	a_TextOut(hdc, 37, 43,  L"Y0");
	a_TextOut(hdc, 37, 73,  L"X~");
	a_TextOut(hdc, 37, 103, L"Y~");
	
	SelectClipRgn(hdc, NULL);
	EndPaint(cv[id].hPd[1], &ps);
}

/*------------------------------------------------------------------------------
    Fvoid CvEdSetFocus(LONG, WPARAM, LPARAM, HWND)
    FLONG    FORM ID
          WPARAM  -
          LPARAM  -
          HWND    -
    @\FEDIT WM_SETFOCUSCxg
------------------------------------------------------------------------------*/
void CvEdSetFocus(LONG id, WPARAM wp, LPARAM lp, HWND hWnd)
{
	INT32 i;
	
	for (i = 0; i < TBSP_CSV; i++) {
		if (hWnd == cv[id].tabStops[i]) {
			cv[id].tabStopIdx = i;
		}
	}
	
	EditSelAll(hWnd);
}

/*------------------------------------------------------------------------------
    Fvoid CvEdKillFocus(LONG, WPARAM, LPARAM, HWND)
    FLONG    FORM ID
          WPARAM  -
          LPARAM  -
          HWND    -
    @\FEDIT WM_KILLFOCUSCxg
------------------------------------------------------------------------------*/
void CvEdKillFocus(LONG id, WPARAM wp, LPARAM lp, HWND hWnd)
{
	INT32 i;
	
	for (i = 0; i < TBSP_CSV; i++) {
		if ((HWND)wp == cv[id].tabStops[i]) {
			CvUpdate(id);
			break;
		}
	}
}

/*------------------------------------------------------------------------------
    FBOOL CvEdChar(LONG, WPARAM, LPARAM, HWND )
    FLONG    FORM ID
          WPARAM  -
          LPARAM  -
          HWND    -
    ߒlFBOOL    -
    @\FEDIT WM_CHARCxg
------------------------------------------------------------------------------*/
BOOL CvEdChar(LONG id, WPARAM wp, LPARAM lp, HWND hWnd)
{
	if ((hWnd == cv[id].hEdit[1]) ||
		(hWnd == cv[id].hEdit[2]) ||
		(hWnd == cv[id].hEdit[3]) ||
		(hWnd == cv[id].hEdit[4]))
	{
		if ((0x30 <= wp) && (wp <= 0x39)) {return TRUE;}	// 0-9
	}
	
	switch (wp) {
	case 0x03:  // ctrl+C
	case 0x08:  // back space
	case 0x16:  // ctrl+V
		return TRUE;
	default:
		return FALSE;
	}
}

/*------------------------------------------------------------------------------
    Fvoid CvBtSetFocus(LONG, WPARAM, LPARAM, HWND)
    FLONG    FORM ID
          WPARAM  -
          LPARAM  -
          HWND    -
    @\FBUTTON WM_SETFOCUSCxg
------------------------------------------------------------------------------*/
void CvBtSetFocus(LONG id, WPARAM wp, LPARAM lp, HWND hWnd)
{
	INT32 i;
	
	for (i = 0; i < TBSP_CSV; i++) {
		if (hWnd == cv[id].tabStops[i]) {
			cv[id].tabStopIdx = i;
		}
	}
}

/*------------------------------------------------------------------------------
    Fvoid CvPcPaint(LONG, WPARAM, LPARAM)
    FLONG    FORM ID
          WPARAM  -
          LPARAM  -
    @\FPC WM_PAINTCxg
------------------------------------------------------------------------------*/
void CvPcPaint(LONG id, WPARAM wp, LPARAM lp)
{
	HDC hdc;
	PAINTSTRUCT ps;
	RECT rc;
	INT32 x1, y1, w1, h1;
	INT32 x2, y2, w2, h2;
	INT32 mode;
	
	hdc = BeginPaint(cv[id].hPc, &ps);
	GetClientRect(cv[id].hPc, &rc);
	SetClipRgn(hdc, &rc);
	
	x2 = 0;
	y2 = 0;
	w2 = cv[id].pc.w;
	h2 = cv[id].pc.h;
	x1 = 0;
	y1 = 0;
	w1 = fm[id].pc[0].img.w;
	h1 = fm[id].pc[0].img.h;
	
	if (cv[id].pc.percent < 10000) {mode = HALFTONE;}
	else                           {mode = COLORONCOLOR;}
	
	SetStretchBltMode(hdc, mode);
	StretchBlt(hdc,               x2, y2, w2, h2,
			   cv[id].pc.tmp.hdc, x1, y1, w1, h1, SRCCOPY);
	
	rc.left   = 0;
	rc.top    = 0;
	rc.right  = w2;
	rc.bottom = h2;
	FrameRect(hdc, &rc, hBrGray);
	
	SelectClipRgn(hdc, NULL);
	EndPaint(cv[id].hPc, &ps);
}

/*------------------------------------------------------------------------------
    Fvoid CvPcLButtonDown(LONG, WPARAM, LPARAM)
    FLONG    FORM ID
          WPARAM  -
          LPARAM  -
    @\FPC WM_LBUTTONDOWNCxg
------------------------------------------------------------------------------*/
void CvPcLButtonDown(LONG id, WPARAM wp, LPARAM lp)
{
	INT32 x;
	INT32 y;
	INT32 xCsv;
	INT32 yCsv;
	WCHAR buff[2][10+1];
	
	x = LOWORD(lp);
	y = HIWORD(lp);
	
	xCsv = (double)(x * fm[id].pc[0].img.w) / cv[id].pc.w;
	yCsv = (double)(y * fm[id].pc[0].img.h) / cv[id].pc.h;
	
	_itow(xCsv, buff[0], 10);
	_itow(yCsv, buff[1], 10);
	SetWindowText(cv[id].hEdit[1], buff[0]);
	SetWindowText(cv[id].hEdit[2], buff[1]);
	UpdateWindow (cv[id].hEdit[1]);
	UpdateWindow (cv[id].hEdit[2]);
	
	CvUpdate(id);
}

/*------------------------------------------------------------------------------
    Fvoid CvEnterBrs(LONG id)
    FLONG    FORM ID
    @\F[browse]{^s
------------------------------------------------------------------------------*/
void CvEnterBrs(LONG id)
{
	OPENFILENAME ofn;
	WCHAR path     [MAX_PATH+1];
	WCHAR pathD    [MAX_PATH];
	WCHAR pathDInit[MAX_PATH];
	WCHAR flt[60] = L"CSV\0*.CSV\0ALL\0*.*\0";
	
	a_memset(path, MAX_PATH+1);
	if (wcslen(cv[id].path) != 0) {
		wcscpy(pathD, cv[id].path);
		PathRemoveFileSpec(pathD);
	}
	else {
		GetModuleFileName(NULL, pathD, MAX_PATH);
		PathRemoveFileSpec(pathD);
	}
	
	memset(&ofn, 0x00, sizeof(OPENFILENAME));
	ofn.lStructSize     = sizeof(OPENFILENAME);
	ofn.hwndOwner       = cv[id].hWnd;
	ofn.hInstance       = NULL;
	ofn.lpstrInitialDir = pathD;
	ofn.lpstrFile       = path;
	ofn.nMaxFile        = MAX_PATH;
	ofn.lpstrFilter     = flt;
	ofn.lpstrDefExt     = L"";
	ofn.lpstrTitle      = TxDl(E_DLGCSV);
	ofn.Flags           = OFN_FILEMUSTEXIST;
	ofn.nFilterIndex    = 1;
	
	if (GetOpenFileName(&ofn) == TRUE) {
		wcscpy(cv[id].path, path);
		
		SetWindowText(cv[id].hEdit[0], cv[id].path);
		
		GetModuleFileName(NULL, pathDInit, MAX_PATH);
		PathRemoveFileSpec(pathDInit);
		SetCurrentDirectory(pathDInit);
		
		CvReadCsv(id);
		CvTmpDraw(id);
		
		InvalidateRect(cv[id].hPc, NULL, FALSE);
		UpdateWindow  (cv[id].hPc);
	}
}

/*------------------------------------------------------------------------------
    Fvoid CvEnterOk(LONG id)
    FLONG    FORM ID
    @\F[OK]{^s
------------------------------------------------------------------------------*/
void CvEnterOk(LONG id)
{
	CvReadCsv(id);
	CvTmpDraw(id);
	InvalidateRect(cv[id].hPc, NULL, FALSE);
	UpdateWindow  (cv[id].hPc);
	if (cv[id].flgUpdate == FALSE) {CLOSE(cv[id].hWnd);  return;}
	
	memcpy(fm[id].pc[0].img.pB, cv[id].pc.tmp.pB, fm[id].pc[0].img.w * fm[id].pc[0].img.h * 4);
	LiImageDelete(id, 0);
	
	InvalidateRect(fm[id].hPict[0],  NULL, TRUE);
	UpdateWindow(fm[id].hPict[0]);
	
	fm[id].flgCsv = TRUE;
	SetFormText(id);
	
	CvStore(id);
	CLOSE(cv[id].hWnd);
}

/*------------------------------------------------------------------------------
    Fvoid CvEnterCan(LONG id)
    FLONG    FORM ID
    @\F[LZ]{^s
------------------------------------------------------------------------------*/
void CvEnterCan(LONG id)
{
	CLOSE(cv[id].hWnd);
}

/*------------------------------------------------------------------------------
    Fvoid CvUpdate(LONG id)
    FLONG    FORM ID
    @\FCSV̕\XV
------------------------------------------------------------------------------*/
void CvUpdate(LONG id)
{
	WCHAR strX_0[5+1];
	WCHAR strY_0[5+1];
	WCHAR strX_A[4+1];
	WCHAR strY_A[4+1];
	INT32 x_0;
	INT32 y_0;
	INT32 x_a;
	INT32 y_a;
	
	GetWindowText(cv[id].hEdit[1], strX_0, 5+1);
	GetWindowText(cv[id].hEdit[2], strY_0, 5+1);
	GetWindowText(cv[id].hEdit[3], strX_A, 4+1);
	GetWindowText(cv[id].hEdit[4], strY_A, 4+1);
	
	x_0 = _wtoi(strX_0);
	y_0 = _wtoi(strY_0);
	x_a = _wtoi(strX_A);
	y_a = _wtoi(strY_A);
	
	if ((x_0 != cv[id].x_0) ||
		(y_0 != cv[id].y_0) ||
		(x_a != cv[id].x_a) ||
		(y_a != cv[id].y_a))
	{
		CvTmpDraw(id);
		
		InvalidateRect(cv[id].hPc, NULL, FALSE);
		UpdateWindow  (cv[id].hPc);
		
		cv[id].flgUpdate = TRUE;
	}
	
	cv[id].x_0 = x_0;
	cv[id].y_0 = y_0;
	cv[id].x_a = x_a;
	cv[id].y_a = y_a;
}

/*------------------------------------------------------------------------------
    Fvoid CvReadCsv(LONG id)
    FLONG    FORM ID
    @\FCSVt@Cǂݍ
------------------------------------------------------------------------------*/
void CvReadCsv(LONG id)
{
	INT32 i;
	ACHAR buffA[LEN_LINE+1];
	WCHAR buffW[LEN_LINE+1];
	HANDLE hFile;
	INT32 cnt;
	INT32 resL;
	INT32 resP;
	INT32 idx;
	
	for (i = 0; i < MAX_CMD; i++) {CvInitParams(&cv[id].prms[i]);}
	cv[id].cntPrms = 0;
	
	CvLinearDelete(id);
	cv[id].cntDefine = 0;
	
	if (!IsExistFile(cv[id].path)) {return;}
	
	hFile = CreateFile(cv[id].path, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING,
					   FILE_ATTRIBUTE_NORMAL , NULL);
	
	if (hFile == INVALID_HANDLE_VALUE) {return;}
	
	idx = 0;
	while (1) {
		if (cv[id].cntPrms >= 1000) {
			MessageBox(NULL, L"over 1000 cmd", L"error", MB_OK);
			CloseHandle(hFile);
			return;
		}
		
		memset(buffA, 0x00, LEN_LINE+1);
		resL = CvReadCsvLine(hFile, buffA, &cnt, idx);
		idx++;
		
		a_memset(buffW, LEN_LINE+1);
//		mbstowcs(buffW, buffA, cnt);
		MultiByteToWideChar(CP_ACP, 0, buffA, -1, buffW, LEN_LINE+1);
		
		if (resL == LINE_OVER) {
			CloseHandle(hFile);
			return;
		}
		
		resP = CvReadCsvParams(id, buffW, idx);
		if ((resP == SEP_OVCHAR) ||
			(resP == SEP_OVPRMS) ||
			(resP == PARAMS_NG))
		{
			CloseHandle(hFile);
			return;
		}
		
		if (resL == LINE_EOF) {break;}
	}
	CloseHandle(hFile);
	
	if (0 < cv[id].cntPrms) {cv[id].flgUpdate = TRUE;}
}

/*------------------------------------------------------------------------------
    FINT32 CvReadCsvLine(HANDLE, ACHAR *, INT32 *, INT32)
    FHANDLE   -
          ACHAR *  -
          INT32 *  -
          INT32    -
    ߒlFINT32    -
    @\FPsǂݍ
------------------------------------------------------------------------------*/
INT32 CvReadCsvLine(HANDLE hFile, ACHAR *buff, INT32 *pCnt, INT32 idx)
{
	INT32 i;
	ULOG32 cnt;
	ACHAR c;
	WCHAR str_print[50];
	
	*pCnt = 0;
	
	i = 0;
	while (1) {
		if (*pCnt >= LEN_LINE) {
			swprintf(str_print, L"%dFover 500 chara in line", idx);
			MessageBox(NULL, str_print, L"error", MB_OK);
			return LINE_OVER;
		}
		
		ReadFile(hFile, &c, 1, &cnt, NULL);
		if (cnt != 1) {return LINE_EOF;}
		
		if (c == '\n') {
			if ((i != 0) && (*(buff + i - 1) == '\r')) {
				*(buff + i - 1) = '\0';
				(*pCnt)--;
			}
			break;
		}
		else {
			*(buff + i) = c;
			(*pCnt)++;
		}
		i++;
	}
	return LINE_OK;
}

/*------------------------------------------------------------------------------
    FINT32 CvReadCsvParams(LONG, WCHAR *, INT32)
    FLONG     -
          WCHAR *  -
          INT32    -
    ߒlFINT32    -
    @\Fp[^𒊏o
------------------------------------------------------------------------------*/
INT32 CvReadCsvParams(LONG id, WCHAR *buff, INT32 idx)
{
	INT32 i;
	WCHAR buffPrms[MAX_PARAMS][LEN_PARAM+1];
	INT32 res;
	INT32 cnt;
	Params prms;
	
	for (i = 0; i < MAX_PARAMS; i++) {a_memset(buffPrms[i], LEN_PARAM+1);}
	CvInitParams(&prms);
	
	res = CvSeparate(buff, buffPrms, &cnt, idx);
	if ((res == SEP_OVCHAR) || (res == SEP_OVPRMS)) {return res;}
	
	CvRemove(buffPrms[0]);
	if (wcscmp(buffPrms[0], L"DEFINE") == 0) {
		res = CvReadCsvParamsDefine(id, &prms, buffPrms, idx, cnt);
		if (res != PARAMS_OK) {return res;}
	}
	else if (wcscmp(buffPrms[0], L"TEXT") == 0) {
		res = CvReadCsvParamsText(id, &prms, buffPrms, idx, cnt);
		if (res != PARAMS_OK) {return res;}
	}
	else if (wcscmp(buffPrms[0], L"LINE") == 0) {
		res = CvReadCsvParamsLine(id, &prms, buffPrms, idx, cnt);
		if (res != PARAMS_OK) {return res;}
	}
	else if (wcscmp(buffPrms[0], L"RECT") == 0) {
		res = CvReadCsvParamsRect(id, &prms, buffPrms, idx, cnt);
		if (res != PARAMS_OK) {return res;}
	}
	else if (wcscmp(buffPrms[0], L"PIXEL") == 0) {
		res = CvReadCsvParamsPixel(id, &prms, buffPrms, idx, cnt);
		if (res != PARAMS_OK) {return res;}
	}
	else if (wcscmp(buffPrms[0], L"MOVETO") == 0) {
		res = CvReadCsvParamsMoveTo(id, &prms, buffPrms, idx, cnt);
		if (res != PARAMS_OK) {return res;}
	}
	else if (wcscmp(buffPrms[0], L"LINETO") == 0) {
		res = CvReadCsvParamsLineTo(id, &prms, buffPrms, idx, cnt);
		if (res != PARAMS_OK) {return res;}
	}
	else if (wcscmp(buffPrms[0], L"FLOOD") == 0) {
		res = CvReadCsvParamsFlood(id, &prms, buffPrms, idx, cnt);
		if (res != PARAMS_OK) {return res;}
	}
	else {
		return PARAMS_OK;
	}
	
	memcpy(&cv[id].prms[cv[id].cntPrms], &prms, sizeof(Params));
	cv[id].cntPrms++;
	
	return PARAMS_OK;
}

/*------------------------------------------------------------------------------
    FINT32 CvReadCsvParamsDefine(LONG, Params *, WCHAR [][LEN_PARAM+1], INT32, INT32)
    FLONG     -
          Params * -
          WCHAR [][LEN_PARAM+1]
          INT32    -
          INT32    -
    ߒlFINT32    -
    @\Fp[^𒊏o DEFINE
------------------------------------------------------------------------------*/
INT32 CvReadCsvParamsDefine(LONG id, Params *pPrms, WCHAR buffPrms[MAX_PARAMS][LEN_PARAM+1], INT32 idx, INT32 cnt)
{
	WCHAR str[50];
	
	if (cnt != 3) {
		swprintf(str, L"%dFdefine wrong params", idx);
		MessageBox(NULL, str, L"error", MB_OK);
		return PARAMS_NG;
	}
	
	pPrms->cmd = CMD_DEFINE;
	
	if (cv[id].cntDefine >= MAX_DEFINE) {
		swprintf(str, L"%dFdefine count over", idx);
		MessageBox(NULL, str, L"error", MB_OK);
		return PARAMS_NG;
	}
	
	CvRemove(buffPrms[1]);
	CvRemove(buffPrms[2]);
	CvReplace(id, buffPrms[2]);
	
	if ((wcslen(buffPrms[1]) == 0) ||
		(wcslen(buffPrms[2]) == 0))
	{
		swprintf(str, L"%dFdefine length 0", idx);
		MessageBox(NULL, str, L"error", MB_OK);
		return PARAMS_NG;
	}
	
	if ((wcslen(buffPrms[1]) >= LEN_SIG) ||
		(wcslen(buffPrms[2]) >= LEN_VAL))
	{
		swprintf(str, L"%dFdefine length over", idx);
		MessageBox(NULL, str, L"error", MB_OK);
		return PARAMS_NG;
	}
	
	if (CvLinearIsExist(id, buffPrms[1])) {
		swprintf(str, L"%dFdefine duplication", idx);
		MessageBox(NULL, str, L"error", MB_OK);
		return PARAMS_NG;
	}
	
	CvLinearInsert(id, buffPrms[1], buffPrms[2]);
	cv[id].cntDefine++;
	
	return PARAMS_OK;
}

/*------------------------------------------------------------------------------
    FINT32 CvReadCsvParamsText(LONG, Params *, WCHAR [][LEN_PARAM+1], INT32, INT32)
    FLONG     -
          Params * -
          WCHAR [][LEN_PARAM+1]
          INT32    -
          INT32    -
    ߒlFINT32    -
    @\Fp[^𒊏o TEXT
------------------------------------------------------------------------------*/
INT32 CvReadCsvParamsText(LONG id, Params *pPrms, WCHAR buffPrms[MAX_PARAMS][LEN_PARAM+1], INT32 idx, INT32 cnt)
{
	WCHAR str[50];
	
	if (cnt != 10) {
		swprintf(str, L"%dFtext wrong params", idx);
		MessageBox(NULL, str, L"error", MB_OK);
		return PARAMS_NG;
	}
	
	pPrms->cmd = CMD_TEXT;
	
	CvRemove(buffPrms[1]);
	CvRemove(buffPrms[2]);
	CvRemove(buffPrms[4]);
	CvRemove(buffPrms[5]);
	CvRemove(buffPrms[6]);
	CvRemove(buffPrms[8]);
	CvRemove(buffPrms[9]);
	
	CvReplace(id, buffPrms[1]);
	CvReplace(id, buffPrms[2]);
	CvReplace(id, buffPrms[4]);
	CvReplace(id, buffPrms[5]);
	CvReplace(id, buffPrms[6]);
	CvReplace(id, buffPrms[8]);
	CvReplace(id, buffPrms[9]);
	
	if (!CvCalc(id, buffPrms[1], &pPrms->x)) {return PARAMS_NG;}
	if (!CvCalc(id, buffPrms[2], &pPrms->y)) {return PARAMS_NG;}
	wcscpy(pPrms->text, buffPrms[3]);
	pPrms->rgb      = _wtor(buffPrms[4]);
	pPrms->back     = _wtor(buffPrms[5]);
	pPrms->flgAlpha = _wtob(buffPrms[6]);
	wcscpy(pPrms->fmy,  buffPrms[7]);
	if (!CvCalc(id, buffPrms[8], &pPrms->size)) {return PARAMS_NG;}
	pPrms->flgVert = _wtob(buffPrms[9]);
	
	if ((pPrms->x < -999) || (9999 < pPrms->x) ||
		(pPrms->y < -999) || (9999 < pPrms->y) ||
		(pPrms->size < 0) || (999  < pPrms->size))
	{
		swprintf(str, L"%dFtext validation params", idx);
		MessageBox(NULL, str, L"error", MB_OK);
		return PARAMS_NG;
	}
	
	return PARAMS_OK;
}

/*------------------------------------------------------------------------------
    FINT32 CvReadCsvParamsLine(LONG, Params *, WCHAR [][LEN_PARAM+1], INT32, INT32)
    FLONG     -
          Params * -
          WCHAR [][LEN_PARAM+1]
          INT32    -
          INT32    -
    ߒlFINT32    -
    @\Fp[^𒊏o LINE
------------------------------------------------------------------------------*/
INT32 CvReadCsvParamsLine(LONG id, Params *pPrms, WCHAR buffPrms[MAX_PARAMS][LEN_PARAM+1], INT32 idx, INT32 cnt)
{
	WCHAR str[50];
	
	if (cnt != 7) {
		swprintf(str, L"%dFline wrong params", idx);
		MessageBox(NULL, str, L"error", MB_OK);
		return PARAMS_NG;
	}
	
	pPrms->cmd = CMD_LINE;
	
	CvRemove(buffPrms[1]);
	CvRemove(buffPrms[2]);
	CvRemove(buffPrms[3]);
	CvRemove(buffPrms[4]);
	CvRemove(buffPrms[5]);
	CvRemove(buffPrms[6]);
	
	CvReplace(id, buffPrms[1]);
	CvReplace(id, buffPrms[2]);
	CvReplace(id, buffPrms[3]);
	CvReplace(id, buffPrms[4]);
	CvReplace(id, buffPrms[5]);
	CvReplace(id, buffPrms[6]);
	
	if (!CvCalc(id, buffPrms[1], &pPrms->x1)) {return PARAMS_NG;}
	if (!CvCalc(id, buffPrms[2], &pPrms->y1)) {return PARAMS_NG;}
	if (!CvCalc(id, buffPrms[3], &pPrms->x2)) {return PARAMS_NG;}
	if (!CvCalc(id, buffPrms[4], &pPrms->y2)) {return PARAMS_NG;}
	pPrms->rgb = _wtor(buffPrms[5]);
	if (!CvCalc(id, buffPrms[6], &pPrms->t))  {return PARAMS_NG;}
	
	if ((pPrms->x1 < -9999) || (9999 < pPrms->x1) ||
		(pPrms->y1 < -9999) || (9999 < pPrms->y1) ||
		(pPrms->x2 < -9999) || (9999 < pPrms->x2) ||
		(pPrms->y2 < -9999) || (9999 < pPrms->y2) ||
		(pPrms->t  < 0)     || (99   < pPrms->t))
	{
		swprintf(str, L"%dFline validation params", idx);
		MessageBox(NULL, str, L"error", MB_OK);
		return PARAMS_NG;
	}
	
	return PARAMS_OK;
}

/*------------------------------------------------------------------------------
    FINT32 CvReadCsvParamsRect(LONG, Params *, WCHAR [][LEN_PARAM+1], INT32, INT32)
    FLONG     -
          Params * -
          WCHAR [][LEN_PARAM+1]
          INT32    -
          INT32    -
    ߒlFINT32    -
    @\Fp[^𒊏o RECT
------------------------------------------------------------------------------*/
INT32 CvReadCsvParamsRect(LONG id, Params *pPrms, WCHAR buffPrms[MAX_PARAMS][LEN_PARAM+1], INT32 idx, INT32 cnt)
{
	WCHAR str[50];
	
	if (cnt != 13) {
		swprintf(str, L"%dFrect wrong params", idx);
		MessageBox(NULL, str, L"error", MB_OK);
		return PARAMS_NG;
	}
	
	pPrms->cmd = CMD_RECT;
	
	CvRemove(buffPrms[1]);
	CvRemove(buffPrms[2]);
	CvRemove(buffPrms[3]);
	CvRemove(buffPrms[4]);
	CvRemove(buffPrms[5]);
	CvRemove(buffPrms[6]);
	CvRemove(buffPrms[7]);
	CvRemove(buffPrms[8]);
	CvRemove(buffPrms[9]);
	CvRemove(buffPrms[10]);
	CvRemove(buffPrms[11]);
	CvRemove(buffPrms[12]);
	
	CvReplace(id, buffPrms[1]);
	CvReplace(id, buffPrms[2]);
	CvReplace(id, buffPrms[3]);
	CvReplace(id, buffPrms[4]);
	CvReplace(id, buffPrms[5]);
	CvReplace(id, buffPrms[6]);
	CvReplace(id, buffPrms[7]);
	CvReplace(id, buffPrms[8]);
	CvReplace(id, buffPrms[9]);
	CvReplace(id, buffPrms[10]);
	CvReplace(id, buffPrms[11]);
	CvReplace(id, buffPrms[12]);
	
	if (!CvCalc(id, buffPrms[1], &pPrms->x)) {return PARAMS_NG;}
	if (!CvCalc(id, buffPrms[2], &pPrms->y)) {return PARAMS_NG;}
	if (!CvCalc(id, buffPrms[3], &pPrms->w)) {return PARAMS_NG;}
	if (!CvCalc(id, buffPrms[4], &pPrms->h)) {return PARAMS_NG;}
	pPrms->rgb     = _wtor(buffPrms[5]);
	pPrms->back    = _wtor(buffPrms[6]);
	if (!CvCalc(id, buffPrms[7], &pPrms->t)) {return PARAMS_NG;}
	if (!CvCalc(id, buffPrms[8], &pPrms->c)) {return PARAMS_NG;}
	pPrms->flgFill = _wtob(buffPrms[9]);
	pPrms->flgOnly = _wtob(buffPrms[10]);
	pPrms->flgElip = _wtob(buffPrms[11]);
	pPrms->flgL    = _wtob(buffPrms[12]);
	
	if ((pPrms->x < -9999) || (9999 < pPrms->x) ||
		(pPrms->y < -9999) || (9999 < pPrms->y) ||
		(pPrms->w < -9999) || (9999 < pPrms->w) ||
		(pPrms->h < -9999) || (9999 < pPrms->h) ||
		(pPrms->t < 0)     || (99   < pPrms->t) ||
		(pPrms->c < 0)     || (999  < pPrms->c))
	{
		swprintf(str, L"%dFrect validation params", idx);
		MessageBox(NULL, str, L"error", MB_OK);
		return PARAMS_NG;
	}
	
	return PARAMS_OK;
}

/*------------------------------------------------------------------------------
    FINT32 CvReadCsvParamsPixel(LONG, Params *, WCHAR [][LEN_PARAM+1], INT32, INT32)
    FLONG     -
          Params * -
          WCHAR [][LEN_PARAM+1]
          INT32    -
          INT32    -
    ߒlFINT32    -
    @\Fp[^𒊏o PIXEL
------------------------------------------------------------------------------*/
INT32 CvReadCsvParamsPixel(LONG id, Params *pPrms, WCHAR buffPrms[MAX_PARAMS][LEN_PARAM+1], INT32 idx, INT32 cnt)
{
	WCHAR str[50];
	
	if (cnt != 4) {
		swprintf(str, L"%dFpixel wrong params", idx);
		MessageBox(NULL, str, L"error", MB_OK);
		return PARAMS_NG;
	}
	
	pPrms->cmd = CMD_PIXEL;
	
	CvRemove(buffPrms[1]);
	CvRemove(buffPrms[2]);
	CvRemove(buffPrms[3]);
	
	CvReplace(id, buffPrms[1]);
	CvReplace(id, buffPrms[2]);
	CvReplace(id, buffPrms[3]);
	
	if(!CvCalc(id, buffPrms[1], &pPrms->x)) {return PARAMS_NG;}
	if(!CvCalc(id, buffPrms[2], &pPrms->y)) {return PARAMS_NG;}
	pPrms->rgb = _wtor(buffPrms[3]);
	
	if ((pPrms->x < -999) || (9999 < pPrms->x) ||
		(pPrms->y < -999) || (9999 < pPrms->y))
	{
		swprintf(str, L"%dFpixel validation params", idx);
		MessageBox(NULL, str, L"error", MB_OK);
		return PARAMS_NG;
	}
	
	return PARAMS_OK;
}

/*------------------------------------------------------------------------------
    FINT32 CvReadCsvParamsMoveTo(LONG, Params *, WCHAR [][LEN_PARAM+1], INT32, INT32)
    FLONG     -
          Params * -
          WCHAR [][LEN_PARAM+1]
          INT32    -
          INT32    -
    ߒlFINT32    -
    @\Fp[^𒊏o MOVETO
------------------------------------------------------------------------------*/
INT32 CvReadCsvParamsMoveTo(LONG id, Params *pPrms, WCHAR buffPrms[MAX_PARAMS][LEN_PARAM+1], INT32 idx, INT32 cnt)
{
	WCHAR str[50];
	
	if (cnt != 5) {
		swprintf(str, L"%dFmoveto wrong params", idx);
		MessageBox(NULL, str, L"error", MB_OK);
		return PARAMS_NG;
	}
	
	pPrms->cmd = CMD_MOVETO;
	
	CvRemove(buffPrms[1]);
	CvRemove(buffPrms[2]);
	CvRemove(buffPrms[3]);
	CvRemove(buffPrms[4]);
	
	CvReplace(id, buffPrms[1]);
	CvReplace(id, buffPrms[2]);
	CvReplace(id, buffPrms[3]);
	CvReplace(id, buffPrms[4]);
	
	if (!CvCalc(id, buffPrms[1], &pPrms->x)) {return PARAMS_NG;}
	if (!CvCalc(id, buffPrms[2], &pPrms->y)) {return PARAMS_NG;}
	pPrms->rgb = _wtor(buffPrms[3]);
	if (!CvCalc(id, buffPrms[4], &pPrms->t)) {return PARAMS_NG;}
	
	if ((pPrms->x < -999) || (9999 < pPrms->x) ||
		(pPrms->y < -999) || (9999 < pPrms->y) ||
		(pPrms->t < 0)    || (99   < pPrms->t))
	{
		swprintf(str, L"%dFmoveto validation params", idx);
		MessageBox(NULL, str, L"error", MB_OK);
		return PARAMS_NG;
	}
	
	return PARAMS_OK;
}

/*------------------------------------------------------------------------------
    FINT32 CvReadCsvParamsLineTo(LONG, Params *, WCHAR [][LEN_PARAM+1], INT32, INT32)
    FLONG     -
          Params * -
          WCHAR [][LEN_PARAM+1]
          INT32    -
          INT32    -
    ߒlFINT32    -
    @\Fp[^𒊏o LINETO
------------------------------------------------------------------------------*/
INT32 CvReadCsvParamsLineTo(LONG id, Params *pPrms, WCHAR buffPrms[MAX_PARAMS][LEN_PARAM+1], INT32 idx, INT32 cnt)
{
	WCHAR str[50];
	
	if (cnt != 3) {
		swprintf(str, L"%dFlineto wrong params", idx);
		MessageBox(NULL, str, L"error", MB_OK);
		return PARAMS_NG;
	}
	
	pPrms->cmd = CMD_LINETO;
	
	CvRemove(buffPrms[1]);
	CvRemove(buffPrms[2]);
	
	CvReplace(id, buffPrms[1]);
	CvReplace(id, buffPrms[2]);
	
	if (!CvCalc(id, buffPrms[1], &pPrms->x)) {return PARAMS_NG;}
	if (!CvCalc(id, buffPrms[2], &pPrms->y)) {return PARAMS_NG;}
	
	if ((pPrms->x < -999) || (9999 < pPrms->x) ||
		(pPrms->y < -999) || (9999 < pPrms->y))
	{
		swprintf(str, L"%dFlineto validation params", idx);
		MessageBox(NULL, str, L"error", MB_OK);
		return PARAMS_NG;
	}
	
	return PARAMS_OK;
}

/*------------------------------------------------------------------------------
    FINT32 CvReadCsvParamsFlood(LONG, Params *, WCHAR [][LEN_PARAM+1], INT32, INT32)
    FLONG     -
          Params * -
          WCHAR [][LEN_PARAM+1]
          INT32    -
          INT32    -
    ߒlFINT32    -
    @\Fp[^𒊏o FLOOD
------------------------------------------------------------------------------*/
INT32 CvReadCsvParamsFlood(LONG id, Params *pPrms, WCHAR buffPrms[MAX_PARAMS][LEN_PARAM+1], INT32 idx, INT32 cnt)
{
	WCHAR str[50];
	
	if (cnt != 4) {
		swprintf(str, L"%dFflood wrong params", idx);
		MessageBox(NULL, str, L"error", MB_OK);
		return PARAMS_NG;
	}
	
	pPrms->cmd = CMD_FLOOD;
	
	CvRemove(buffPrms[1]);
	CvRemove(buffPrms[2]);
	CvRemove(buffPrms[3]);
	
	CvReplace(id, buffPrms[1]);
	CvReplace(id, buffPrms[2]);
	CvReplace(id, buffPrms[3]);
	
	if (!CvCalc(id, buffPrms[1], &pPrms->x)) {return PARAMS_NG;}
	if (!CvCalc(id, buffPrms[2], &pPrms->y)) {return PARAMS_NG;}
	pPrms->rgb = _wtor(buffPrms[3]);
	
	if ((pPrms->x < -999) || (9999 < pPrms->x) ||
		(pPrms->y < -999) || (9999 < pPrms->y))
	{
		swprintf(str, L"%dFflood validation params", idx);
		MessageBox(NULL, str, L"error", MB_OK);
		return PARAMS_NG;
	}
	
	return PARAMS_OK;
}

/*------------------------------------------------------------------------------
    FINT32 CvSeparate(WCHAR *, WCHAR [][], INT32 *, INT32)
    FWCHAR *     -
          WCHAR [][]  -
          INT32 *     -
          INT32       -
    ߒlFINT32       -
    @\FJ}ŋ؂
------------------------------------------------------------------------------*/
INT32 CvSeparate(WCHAR *buff, WCHAR buffPrms[][LEN_PARAM+1], INT32 *pCnt, INT32 idx)
{
	INT32 i;
	INT32 idxPrms;
	INT32 idxChar;
	WCHAR c;
	WCHAR str_print[50];
	
	idxPrms = 0;
	idxChar = 0;
	
	i = 0;
	while (1) {
		if (idxChar >= LEN_PARAM) {
			swprintf(str_print, L"%dFover 100 chara in param", idx);
			MessageBox(NULL, str_print, L"error", MB_OK);
			return SEP_OVCHAR;
		}
		if (idxPrms >= MAX_PARAMS) {
			swprintf(str_print, L"%dFover params", idx);
			MessageBox(NULL, str_print, L"error", MB_OK);
			return SEP_OVPRMS;
		}
		
		c = *(buff + i);
		
		if (c == L'\0') {
			break;
		}
		else if (c == L',') {
			idxPrms++;
			idxChar = 0;
		}
		else {
			buffPrms[idxPrms][idxChar] = c;
			idxChar++;
		}
		i++;
	}
	
	*pCnt = idxPrms + 1;
	return SEP_OK;
}

/*------------------------------------------------------------------------------
    Fvoid CvRemove(WCHAR *)
    FWCHAR *    -
    @\F󔒂ƃ^u폜
------------------------------------------------------------------------------*/
void CvRemove(WCHAR *buff)
{
	WCHAR *dst = buff;
	WCHAR *src = buff;
	
	while (*src) {
		if ((*src == L' ') ||
			(*src == L'\t'))
		{
			src++;
			continue;
		}
		*dst = *src;
		
		dst++;
		src++;
	}
	*dst = L'\0';
}

/*------------------------------------------------------------------------------
    Fvoid CvReplace(LONG, WCHAR *)
    FLONG      -
          WCHAR *   -
    @\F`ւ
------------------------------------------------------------------------------*/
void CvReplace(LONG id, WCHAR *buff)
{
	INT32 i;
	INT32 cnt;
	WCHAR *pStr;
	WCHAR *pRes;
	WCHAR tmp1[LEN_VAL+1];
	WCHAR tmp2[LEN_VAL+1];
	Linear *pCur;
	
	a_memset(tmp1, LEN_VAL+1);
	a_memset(tmp2, LEN_VAL+1);
	
	wcscpy(tmp1, buff);
	pStr = tmp1;
	
	pCur = cv[id].root.next;
	
	for (i = 0; i < cv[id].cntDefine; i++) {
		while (1) {
			pRes = wcsstr(pStr, pCur->sig);
			if (pRes != NULL) {
				cnt = pRes - pStr;
				
				wcsncat(tmp2, pStr, cnt);
				wcscat (tmp2, pCur->val);
				
				pStr = pRes + wcslen(pCur->sig);
			}
			else {
				wcscat(tmp2, pStr);
				break;
			}
		}
		wcscpy(tmp1, tmp2);
		pStr = tmp1;
		a_memset(tmp2, LEN_VAL+1);
		
		pCur = pCur->next;
	}
	a_memset(buff, LEN_VAL+1);
	wcscpy(buff, tmp1);
}

/*------------------------------------------------------------------------------
    FBOOL CvCalc(LONG id, const WCHAR *const, INT32 *)
    FLONG id             -
          const WCHAR *const  -
          INT32 *             -
    ߒlFBOOL                -
    @\Fp[^̒̐vZ
------------------------------------------------------------------------------*/
BOOL CvCalc(LONG id, const WCHAR *const str, INT32 *val)
{
	INT32 res;
	WCHAR msg[PLSH_RESCNT][30+1] = {L"error check block",
									L"error formula",
									L"error expression",
									L"error len",
									L"error term cnt l",
									L"error term cnt r",
									L"error push decode",
									L"error decode div 0",
									L"error decode remain",};
	
	res = Calc(str, val);
	
	if (res != PLSH_NOERROR) {
		MessageBox(fm[id].hWnd, msg[res], L_TITLE, MB_OK);
		return FALSE;
	}
	return TRUE;
}

/*------------------------------------------------------------------------------
    Fvoid CvLinearIsExist(LONG, WCHAR *)
    FLONG      -
          WCHAR *   -
    @\FjAɊɂ邩ǂ
------------------------------------------------------------------------------*/
BOOL CvLinearIsExist(LONG id, WCHAR *sig)
{
	Linear *pCur;
	
	pCur = cv[id].root.next;
	
	while (pCur != NULL) {
		if (wcscmp(pCur->sig, sig) == 0) {return TRUE;}
		pCur = pCur->next;
	}
	return FALSE;
}

/*------------------------------------------------------------------------------
    Fvoid CvLinearInsert(LONG, WCHAR *, WCHAR *)
    FLONG      -
          WCHAR *   -
          WCHAR *   -
    @\FjAɍ
------------------------------------------------------------------------------*/
void CvLinearInsert(LONG id, WCHAR *sig, WCHAR *val)
{
	Linear *pCur;
	
	if (cv[id].root.next == NULL) {
		CvLinearAdd(id, &cv[id].root, sig, val);
		return;
	}
	
	pCur = &cv[id].root;
	
	while (1) {
		if (pCur->next == NULL) {
			CvLinearAdd(id, pCur, sig, val);
			return;
		}
		
		if (wcslen(sig) >= wcslen(pCur->next->sig)) {
			CvLinearAdd(id, pCur, sig, val);
			return;
		}
		pCur = pCur->next;
	}
}

/*------------------------------------------------------------------------------
    Fvoid CvLinearAdd(LONG, Linear *, WCHAR *, WCHAR *)
    FLONG      -
          Linear *  -
          WCHAR *   -
          WCHAR *   -
    @\FjAɒǉ
------------------------------------------------------------------------------*/
void CvLinearAdd(LONG id, Linear *pCur, WCHAR *sig, WCHAR *val)
{
	Linear *pTmp;
	
	pTmp = (Linear *)a_malloc(sizeof(Linear));
	a_memset(pTmp->sig, LEN_SIG+1);
	a_memset(pTmp->val, LEN_VAL+1);
	wcscpy(pTmp->sig, sig);
	wcscpy(pTmp->val, val);
	pTmp->next = pCur->next;
	pCur->next = pTmp;
}

/*------------------------------------------------------------------------------
    Fvoid CvLinearDelete(LONG)
    FLONG      -
    @\FjA폜
------------------------------------------------------------------------------*/
void CvLinearDelete(LONG id)
{
	Linear *pCur;
	Linear *pDel;
	
	if (cv[id].root.next == NULL) {return;}
	pCur = cv[id].root.next;
	
	do {
		pDel = pCur;
		pCur = pCur->next;
		free(pDel);
	} while (pCur != NULL);
	
	cv[id].root.next = NULL;
}

/*------------------------------------------------------------------------------
    Fvoid CvLinearDump(LONG)
    FLONG      -
    @\FjA̓eo
------------------------------------------------------------------------------*/
void CvLinearDump(LONG id)
{
	INT32 i;
	Linear *pCur;
	WCHAR str_print[3000];
	
	a_memset(str_print, 3000);
	
	i = 0;
	pCur = cv[id].root.next;
	
	while (pCur != NULL) {
		if (30 < i) {
			MessageBox(NULL, str_print, L_TITLE, MB_OK);
			a_memset(str_print, 3000);
			i = 0;
		}
		
		wcscat(str_print, pCur->sig);
		wcscat(str_print, L",\t");
		wcscat(str_print, pCur->val);
		wcscat(str_print, L"\r\n");
		
		pCur = pCur->next;
		i++;
	}
	
	MessageBox(NULL, str_print, L_TITLE, MB_OK);
}

/*------------------------------------------------------------------------------
    Fvoid CvTmpCreate(LONG, INT32, INT32)
    FLONG     FORM ID
          INT32    
          INT32    
    @\FꎞC[W쐬
------------------------------------------------------------------------------*/
void CvTmpCreate(LONG id, INT32 w, INT32 h)
{
	RECT rc;
	
	ImageCreate(&cv[id].pc.tmp, w, h);
	
	rc.left   = 0;
	rc.top    = 0;
	rc.right  = w;
	rc.bottom = h;
	SetClipRgn(cv[id].pc.tmp.hdc, &rc);
}

/*------------------------------------------------------------------------------
    Fvoid CvTmpDraw(LONG)
    FLONG     FORM ID
    @\FꎞC[W`
------------------------------------------------------------------------------*/
void CvTmpDraw(LONG id)
{
	INT32 i;
	
	memcpy(cv[id].pc.tmp.pB, fm[id].pc[0].img.pB, fm[id].pc[0].img.w * fm[id].pc[0].img.h * 4);
	
	for (i = 0; i < cv[id].cntPrms; i++) {
		switch (cv[id].prms[i].cmd) {
		case CMD_TEXT:    CvTmpDrawText  (id, &cv[id].prms[i]);  break;
		case CMD_LINE:    CvTmpDrawLine  (id, &cv[id].prms[i]);  break;
		case CMD_RECT:    CvTmpDrawRect  (id, &cv[id].prms[i]);  break;
		case CMD_PIXEL:   CvTmpDrawPixel (id, &cv[id].prms[i]);  break;
		case CMD_MOVETO:  CvTmpDrawMoveto(id, &cv[id].prms[i]);  break;
		case CMD_LINETO:  CvTmpDrawLineto(id, &cv[id].prms[i]);  break;
		case CMD_FLOOD:   CvTmpDrawFlood (id, &cv[id].prms[i]);  break;
		default: break;
		}
	}
}

/*------------------------------------------------------------------------------
    Fvoid CvTmpDrawText(LONG, Params *)
    FLONG      FORM ID
          Params *  -
    @\F̕`
------------------------------------------------------------------------------*/
void CvTmpDrawText(LONG id, Params *pPrms)
{
	HDC hdc;
	HFONT hFt;
	HFONT hFtOld;
	WCHAR fmy[100+1];
	INT32 escapement;
	INT32 x;
	INT32 y;
	INT32 xMv;
	INT32 mode;
	
	hdc = cv[id].pc.tmp.hdc;
	x = CvX(id, pPrms->x);
	y = CvY(id, pPrms->y);
	
	if (pPrms->flgVert == TRUE) {swprintf(fmy, L"@%s", pPrms->fmy); xMv = pPrms->size; escapement = 2700;}
	else                        {swprintf(fmy, L"%s",  pPrms->fmy); xMv = 0;           escapement = 0;}
	
	hFt = CreateFont(pPrms->size, 0, escapement, 0, FW_DONTCARE,
					 FALSE, FALSE, FALSE,
					 ANSI_CHARSET,
					 OUT_DEFAULT_PRECIS,
					 CLIP_DEFAULT_PRECIS,
					 DEFAULT_QUALITY,
					 DEFAULT_PITCH|FF_DONTCARE, fmy);
	
	SetTextColor(hdc, pPrms->rgb);
	SetBkColor  (hdc, pPrms->back);
	
	if (pPrms->flgAlpha) {mode = TRANSPARENT;}
	else                 {mode = OPAQUE;}
	SetBkMode(hdc, mode);
	
	hFtOld = (HFONT)SelectObject(hdc, hFt);
	
	a_TextOut(hdc, x + xMv, y, pPrms->text);
	
	SelectObject(hdc, hFtOld);
	DeleteObject(hFt);
}

/*------------------------------------------------------------------------------
    Fvoid CvTmpDrawLine(LONG, Params *)
    FLONG      FORM ID
          Params *  -
    @\F̕`
------------------------------------------------------------------------------*/
void CvTmpDrawLine(LONG id, Params *pPrms)
{
	HDC hdc;
	HPEN hPen;
	HPEN hPenOld;
	INT32 x1;
	INT32 y1;
	INT32 x2;
	INT32 y2;
	
	hdc = cv[id].pc.tmp.hdc;
	x1 = CvX(id, pPrms->x1);
	y1 = CvY(id, pPrms->y1);
	x2 = CvX(id, pPrms->x2);
	y2 = CvY(id, pPrms->y2);
	
	SetBkMode(hdc, TRANSPARENT);
	hPen = CreatePen(PS_SOLID, pPrms->t, pPrms->rgb);
	hPenOld = (HPEN)SelectObject(hdc, hPen);
	
	MoveToEx(hdc, x1, y1, NULL);
	LineTo  (hdc, x2, y2);
	
	SelectObject(hdc, hPenOld);
	DeleteObject(hPen);
}

/*------------------------------------------------------------------------------
    Fvoid CvTmpDrawRect(LONG, Params *)
    FLONG      FORM ID
          Params *  -
    @\F`̕`
------------------------------------------------------------------------------*/
void CvTmpDrawRect(LONG id, Params *pPrms)
{
	HDC hdc;
	HPEN   hPen;
	HBRUSH hBr;
	HPEN   old1;
	HBRUSH old2;
	INT32 x;
	INT32 y;
	INT32 w;
	INT32 h;
	
	hdc = cv[id].pc.tmp.hdc;
	x = CvX(id, pPrms->x);
	y = CvY(id, pPrms->y);
	w = CvW(id, pPrms->w);
	h = CvH(id, pPrms->h);
	
	if ((pPrms->flgOnly == TRUE) && (pPrms->flgL == FALSE)) {
		hPen = CreatePen(PS_SOLID, pPrms->t, pPrms->back);
	}
	else {
		hPen = CreatePen(PS_SOLID, pPrms->t, pPrms->rgb);
	}
	old1 = (HPEN)SelectObject(hdc, hPen);
	
	hBr  = CreateSolidBrush(pPrms->back);
	old2 = (HBRUSH)SelectObject(hdc, hBr);
	
	if (pPrms->flgL == TRUE) {
		MoveToEx(hdc, x,     y, NULL);
		LineTo  (hdc, x,     y + h);
		LineTo  (hdc, x + w, y + h);
	}
	else if (pPrms->flgElip == TRUE) {
		if      (pPrms->flgOnly == TRUE)  {/*SelectObject(hdc, hPnNull);*/}
		else if (pPrms->flgFill == FALSE) {SelectObject(hdc, hBrNull);}
		Ellipse(hdc, x, y, x + w, y + h);
	}
	else {
		if      (pPrms->flgOnly == TRUE)  {/*SelectObject(hdc, hPnNull);*/}
		else if (pPrms->flgFill == FALSE) {SelectObject(hdc, hBrNull);}
		
		if (pPrms->c != 0) {
			RoundRect(hdc, x, y, x + w, y + h, pPrms->c, pPrms->c);
		}
		else {
			Rectangle(hdc, x, y, x + w, y + h);
		}
	}
	
	SelectObject(hdc, old1);
	SelectObject(hdc, old2);
	DeleteObject(hPen);
	DeleteObject(hBr);
}

/*------------------------------------------------------------------------------
    Fvoid CvTmpDrawPixel(LONG, Params *)
    FLONG      FORM ID
          Params *  -
    @\FsNZ̕`
------------------------------------------------------------------------------*/
void CvTmpDrawPixel(LONG id, Params *pPrms)
{
	HDC hdc;
	INT32 x;
	INT32 y;
	
	hdc = cv[id].pc.tmp.hdc;
	x = CvX(id, pPrms->x);
	y = CvY(id, pPrms->y);
	
	SetPixel(hdc, x, y, pPrms->rgb);
}

/*------------------------------------------------------------------------------
    Fvoid CvTmpDrawMoveto(LONG, Params *)
    FLONG      FORM ID
          Params *  -
    @\Fn_̕`
------------------------------------------------------------------------------*/
void CvTmpDrawMoveto(LONG id, Params *pPrms)
{
	HDC hdc;
	INT32 x;
	INT32 y;
	
	hdc = cv[id].pc.tmp.hdc;
	x = CvX(id, pPrms->x);
	y = CvY(id, pPrms->y);
	
	SelectObject(hdc, cv[id].old);
	DeleteObject(cv[id].hPn);
	
	cv[id].hPn = CreatePen(PS_SOLID, pPrms->t, pPrms->rgb);
	cv[id].old = (HPEN)SelectObject(hdc, cv[id].hPn);
	
	MoveToEx(hdc, x, y, NULL);
	LineTo  (hdc, x, y);
}

/*------------------------------------------------------------------------------
    Fvoid CvTmpDrawLineto(LONG, Params *)
    FLONG      FORM ID
          Params *  -
    @\Fp̕`
------------------------------------------------------------------------------*/
void CvTmpDrawLineto(LONG id, Params *pPrms)
{
	HDC hdc;
	INT32 x;
	INT32 y;
	
	hdc = cv[id].pc.tmp.hdc;
	x = CvX(id, pPrms->x);
	y = CvY(id, pPrms->y);
	
	LineTo(hdc, x, y);
}

/*------------------------------------------------------------------------------
    Fvoid CvTmpDrawFlood(LONG, Params *)
    FLONG      FORM ID
          Params *  -
    @\FhԂ̕`
------------------------------------------------------------------------------*/
void CvTmpDrawFlood(LONG id, Params *pPrms)
{
	HDC hdc;
	INT32 x;
	INT32 y;
	HBRUSH hBr;
	HBRUSH old;
	INT32 target;
	
	hdc = cv[id].pc.tmp.hdc;
	x = CvX(id, pPrms->x);
	y = CvY(id, pPrms->y);
	
	hBr = CreateSolidBrush(pPrms->rgb);
	old = (HBRUSH)SelectObject(hdc, hBr);
	
	target = GetPixel(hdc, x, y);
	ExtFloodFill(hdc, x, y, target, FLOODFILLSURFACE);
	
	SelectObject(hdc, old);
	DeleteObject(hBr);
}

/*------------------------------------------------------------------------------
    Fvoid CvTmpDelete(LONG)
    FLONG     FORM ID
    @\FꎞC[W폜
------------------------------------------------------------------------------*/
void CvTmpDelete(LONG id)
{
	SelectClipRgn(cv[id].pc.tmp.hdc, NULL);
	DeleteDC    (cv[id].pc.tmp.hdc);
	DeleteObject(cv[id].pc.tmp.hBmp);
}

/*------------------------------------------------------------------------------
    FINT32 CvX(LONG, INT32)
    FLONG     FORM ID
          INT32    XW
    @\FXWvZ
------------------------------------------------------------------------------*/
INT32 CvX(LONG id, INT32 x)
{
	WCHAR strX_0[5+1];
	WCHAR strX_A[4+1];
	INT32 x_0;
	INT32 x_a;
	
	GetWindowText(cv[id].hEdit[1], strX_0, 5+1);
	GetWindowText(cv[id].hEdit[3], strX_A, 4+1);
	
	x_0 = _wtoi(strX_0);
	x_a = _wtoi(strX_A);
	
	x *= (double)x_a / 1000;
	x += x_0;
	return x;
}

/*------------------------------------------------------------------------------
    FINT32 CvY(LONG, INT32)
    FLONG     FORM ID
          INT32    YW
    @\FYWvZ
------------------------------------------------------------------------------*/
INT32 CvY(LONG id, INT32 y)
{
	WCHAR strY_0[5+1];
	WCHAR strY_A[4+1];
	INT32 y_0;
	INT32 y_a;
	
	GetWindowText(cv[id].hEdit[2], strY_0, 5+1);
	GetWindowText(cv[id].hEdit[4], strY_A, 4+1);
	
	y_0 = _wtoi(strY_0);
	y_a = _wtoi(strY_A);
	
	y *= (double)y_a / 1000;
	y += y_0;
	return y;
}

/*------------------------------------------------------------------------------
    FINT32 CvW(LONG, INT32)
    FLONG     FORM ID
          INT32    
    @\FvZ
------------------------------------------------------------------------------*/
INT32 CvW(LONG id, INT32 w)
{
	WCHAR strX_A[4+1];
	INT32 x_a;
	
	GetWindowText(cv[id].hEdit[3], strX_A, 4+1);
	
	x_a = _wtoi(strX_A);
	
	w *= (double)x_a / 1000;
	return w;
}

/*------------------------------------------------------------------------------
    FINT32 CvH(LONG, INT32)
    FLONG     FORM ID
          INT32    
    @\FvZ
------------------------------------------------------------------------------*/
INT32 CvH(LONG id, INT32 h)
{
	WCHAR strY_A[4+1];
	INT32 y_a;
	
	GetWindowText(cv[id].hEdit[4], strY_A, 4+1);
	
	y_a = _wtoi(strY_A);
	
	h *= (double)y_a / 1000;
	return h;
}

/*------------------------------------------------------------------------------
    Fvoid CvImageView(LONG)
    FLONG    FORM ID
    @\FCSV\p
------------------------------------------------------------------------------*/
void CvImageView(LONG id)
{
	double gainW, gainH;
	INT32 x, y, w, h;
	BOOL limW = FALSE;
	BOOL limH = FALSE;
	
	TryZeroDivision(fm[id].pc[0].img.w);
	TryZeroDivision(fm[id].pc[0].img.h);
	gainW = (double)cv[id].cn.w / fm[id].pc[0].img.w;
	gainH = (double)cv[id].cn.h / fm[id].pc[0].img.h;
	
	if ((1 < gainW) && (1 < gainH)) {
		gainW = gainH = (double)1;
	}
	else {
		if (CmpGain(gainW, gainH) == TRUE) {
			limW = TRUE;
			limH = TRUE;
		}
		else {
			if (gainW < gainH) {
				gainH = gainW;
				limW = TRUE;
			}
			else {
				gainW = gainH;
				limH = TRUE;
			}
		}
	}
	
	x = (double)cv[id].cn.w / 2 - (double)fm[id].pc[0].img.w * gainW / 2;
	y = (double)cv[id].cn.h / 2 - (double)fm[id].pc[0].img.h * gainH / 2;
	w = (double)fm[id].pc[0].img.w * gainW;
	h = (double)fm[id].pc[0].img.h * gainH;
	
	if (limW == TRUE) {x = 0;  w = cv[id].cn.w;}
	if (limH == TRUE) {y = 0;  h = cv[id].cn.h;}
	
	if (limW == TRUE) {TryZeroDivision(fm[id].pc[0].img.w);  cv[id].pc.percent = ((double)w / fm[id].pc[0].img.w) * 10000;}
	else              {TryZeroDivision(fm[id].pc[0].img.h);  cv[id].pc.percent = ((double)h / fm[id].pc[0].img.h) * 10000;}
	
	cv[id].pc.x = x;
	cv[id].pc.y = y;
	if (w <= 0) {cv[id].pc.w = 1;}
	else        {cv[id].pc.w = w;}
	if (h <= 0) {cv[id].pc.h = 1;}
	else        {cv[id].pc.h = h;}
}

/*------------------------------------------------------------------------------
    Fvoid CvSetPane(LONG)
    FLONG    FORM ID
    @\FCSV̕\̘g\
------------------------------------------------------------------------------*/
void CvSetPane(LONG id)
{
	RECT rc;
	INT32 w;
	INT32 h;
	
	GetClientRect(cv[id].hPd[2], &rc);
	w = rc.right - rc.left;
	h = rc.bottom - rc.top;
	a_SetWindowPos(cv[id].hCn, PADD8, PADD8, w-PADD8*2, h-PADD8*2);
	
	GetClientRect(cv[id].hCn, &rc);
	cv[id].cn.x = rc.left;
	cv[id].cn.y = rc.top;
	cv[id].cn.w = rc.right - rc.left;
	cv[id].cn.h = rc.bottom - rc.top;
}
